		/*ontouchstart="touchStart(event,'swipeBox');"
		ontouchend="touchEnd(event);" ontouchmove="touchMove(event);"
		ontouchcancel="touchCancel(event);"
		*/

// TOUCH-EVENTS SINGLE-FINGER SWIPE-SENSING JAVASCRIPT
			// Courtesy of PADILICIOUS.COM and MACOSXAUTOMATION.COM
			
			// this script can be used with one or more page elements to perform actions based on them being swiped with a single finger
		
			var triggerElementID = null; // this variable is used to identity the triggering element
			var fingerCount = 0;
			var startX = 0;
			var startY = 0;
			var curX = 0;
			var curY = 0;
			var deltaX = 0;
			var deltaY = 0;
			var horzDiff = 0;
			var vertDiff = 0;
			var minLength = 72; // the shortest distance the user may swipe
			var swipeLength = 0;
			var swipeAngle = null;
			var swipeDirection = null;
			
			// The 4 Touch Event Handlers
			
			// NOTE: the touchStart handler should also receive the ID of the triggering element
			// make sure its ID is passed in the event call placed in the element declaration, like:
			// <div id="picture-frame" ontouchstart="touchStart(event,'picture-frame');"  ontouchend="touchEnd(event);" ontouchmove="touchMove(event);" ontouchcancel="touchCancel(event);">
		
			function touchStart(event,passedName) {
				// disable the standard ability to select the touched object
				//event.preventDefault();
				// get the total number of fingers touching the screen
				fingerCount = event.touches.length;
				// since we're looking for a swipe (single finger) and not a gesture (multiple fingers),
				// check that only one finger was used
				if ( fingerCount == 1 ) {
					// get the coordinates of the touch
					startX = event.touches[0].pageX;
					startY = event.touches[0].pageY;
					// store the triggering element ID
					triggerElementID = passedName;
				} else {
					// more than one finger touched so cancel
					touchCancel(event);
				}
			}
		
			function touchMove(event) {
				//event.preventDefault();
				if ( event.touches.length == 1 ) {
					curX = event.touches[0].pageX;
					curY = event.touches[0].pageY;
				} else {
					touchCancel(event);
				}
			}
			
			function touchEnd(event) {
				//event.preventDefault();
				// check to see if more than one finger was used and that there is an ending coordinate
				if ( fingerCount == 1 && curX != 0 ) {
					// use the Distance Formula to determine the length of the swipe
					swipeLength = Math.round(Math.sqrt(Math.pow(curX - startX,2) + Math.pow(curY - startY,2)));
					// if the user swiped more than the minimum length, perform the appropriate action
					if ( swipeLength >= minLength ) {
						caluculateAngle();
						determineSwipeDirection();
						processingRoutine();
						touchCancel(event); // reset the variables
					} else {
						touchCancel(event);
					}	
				} else {
					touchCancel(event);
				}
			}
		
			function touchCancel(event) {
				// reset the variables back to default values
				fingerCount = 0;
				startX = 0;
				startY = 0;
				curX = 0;
				curY = 0;
				deltaX = 0;
				deltaY = 0;
				horzDiff = 0;
				vertDiff = 0;
				swipeLength = 0;
				swipeAngle = null;
				swipeDirection = null;
				triggerElementID = null;
			}
			
			function caluculateAngle() {
				var X = startX-curX;
				var Y = curY-startY;
				var Z = Math.round(Math.sqrt(Math.pow(X,2)+Math.pow(Y,2))); //the distance - rounded - in pixels
				var r = Math.atan2(Y,X); //angle in radians (Cartesian system)
				swipeAngle = Math.round(r*180/Math.PI); //angle in degrees
				if ( swipeAngle < 0 ) { swipeAngle =  360 - Math.abs(swipeAngle); }
			}
			
			function determineSwipeDirection() {
				if ( (swipeAngle <= 40) && (swipeAngle >= 0) ) {
					swipeDirection = 'left';
				} else if ( (swipeAngle <= 360) && (swipeAngle >= 320) ) {
					swipeDirection = 'left';
				} else if ( (swipeAngle >= 140) && (swipeAngle <= 230) ) {
					swipeDirection = 'right';
				} else if ( (swipeAngle > 40) && (swipeAngle < 140) ) {
					swipeDirection = 'down';
				} else {
					swipeDirection = 'up';
				}
				/*
                jslog("i","swipe: direction " + swipeDirection + " swipeAngle " + swipeAngle );
                 */
			}

			function processingRoutine() {
				menuswipe(swipeDirection)
			}
			
function init_swipe() {
global.page_count = 0;
global.swipe_pages = ["indexpage","questionpage","helppage"];
global.swipe_pages_r = null;
}
    
			function goback() {
				menuswipe('right');
			}
			
			function gomenu() {
				global.page_count = 0;
				switchpage(global.swipe_pages[global.page_count]);
			}

			function menuswipe(swipeDirection1) {

      if (!contains(global.swipe_pages,global.current_page)) {
        jslog("i","ingoring swipe as not on swipable page:" + global.current_page);
        return false;
      }

				jslog("i","swipe: processing " + swipeDirection1 + " page_count = " + global.page_count + " page count = "  + global.swipe_pages.length);
				pagelen = global.swipe_pages.length;
				var swipedElement = document.getElementById(triggerElementID);
				if ( swipeDirection1 == 'right' ) {
					global.page_count -= 1;
					if (global.page_count < 0) {
						global.page_count = 0;
					}
					switchpage(global.swipe_pages[global.page_count]);
				} else if ( swipeDirection1 == 'left' ) {
					global.page_count += 1;
					if (global.page_count > pagelen-1) {
						global.page_count = pagelen-1;
					}
					switchpage(global.swipe_pages[global.page_count]);
				} else if ( swipeDirection1 == 'up' ) {
					// REPLACE WITH YOUR ROUTINES
					//swipedElement.style.backgroundColor = 'maroon';
				} else if ( swipeDirection1 == 'down' ) {
					// REPLACE WITH YOUR ROUTINES
					//swipedElement.style.backgroundColor = 'purple';
				}
				jslog("i","swipe: processed " + swipeDirection1 + " page_count = " + global.page_count);
			}
