function onDeviceReady() {
    try {
        global.beta = false;
        global.livedebug = false;
        global.data_update = null;
        //current version
        global.current_app_version = 18;
        appversion = window.localStorage.getItem("app_version");
        question_count = window.localStorage.getItem("question_count");
        var upgradedb = false;
        if (appversion != global.current_app_version) {
            // app version was never set before hand and there is questions
            // before appversion sqlite db was used to store questions
            // so upgrade db
            if (appversion === null && question_count !== null)
                upgradedb = true;
        }
        window.localStorage.setItem("app_version", global.current_app_version);
        // if too many errors when access questions drop the table and recreate
        //	var quest = null;
        // flag for when Example questions is moved to left column
        // on a narrow screen it would put it bellow contact info

        global.hasmoved = false;
        global.question_template = null;
        global.unique_formatanswer_count = 0;
        global.upload_count = 0;
        global.isUpdating = false;
        global.skipped_questions = {};
        global.addquestions_queue = [];
        global.process_addquestions_queue_lock = false;
        global.sid = null;
        global.uuid = null;
        // set when you want update questions to force an update of my questions list
        // after completed force_update is set to false again
        global.force_update = false;
        global.stats = null;
        // set to true to ignore next resume / update questions
        global.noupdate = false;
        global.default_questions = [];
        global.questions_cache = {};
        global.question_for_student = null;
        global.question_count = 0;
        global.app_version = 2; //api version
        global.max_survey_questions = 2;
        global.question_uuid = null;
        global.questionfileURI = null;
        global.description = null;
        global.questionid = null;
        global.upload_name = null;
        global.image = {};
        global.image_upload_status = {};
        global.removeimages = [];

        // how many videos has the user submited according to the server
        global.contribution = localObject("global.contribution");
        if (typeof global.contribution.videos == "undefined")
            global.contribution.videos = 0;
        if (typeof global.contribution.lessons == "undefined")
            global.contribution.lessons = 0;


        init_functions();
        init_hwkhlp();
        //init_swipe();
        /*ontouchstart="touchStart(event,'swipeBox');"
		ontouchend="touchEnd(event);" ontouchmove="touchMove(event);"
		ontouchcancel="touchCancel(event);"
		*/

        // confirmation that these messages have been received and sent back to server
        global.confirmedreceived = localStorage2Array("global.confirmedreceived");

        // how many completed lessons
        global.lesson_complete_count = localNumber("global.lesson_complete_count");

        // set to true when lesson is open for editing
        global.lesson_editing = false;

        global.answeraccess = localStorage2Array("global.answeraccess");

        global.purchases_uuid = localStorage2Array("purchases_uuid");
        global.purchases_id = localStorage2Array("purchases_id");
        global.questions_ignore = localStorage2Array("global.questions_ignore");
        global.loadedquestions = null;
        if (null !== window.localStorage.getItem("global.loadedquestions"))
            global.loadedquestions = localObject("global.loadedquestions");
        // pre load questions that could be answered
        if (global.loadedquestions === null) {
            global.loadedquestions = global.loadedquestionst;
        }
        if (typeof global.loadedquestionst !== "undefined")
            delete global.loadedquestionst;
        else {
            jslog("e", "global.loadedquestionst undefined");
        }
        global.loadedtopquestions = null;
        if (null !== window.localStorage.getItem("global.loadedtopquestions"))
            global.loadedtopquestions = localObject("global.loadedtopquestions");

        global.school_level = window.localStorage.getItem("school_level");
        global.last_school_level = null;
        global.questions = [];
        if (upgradedb) {
            jslog("i", "upgrading db calling initDB");
            initDB();
        } else {}
        global.questions = localStorage2Array("global.questions");
        //jslog("i","global.questions = " + window.localStorage.getItem("global.questions"));
        updateQuestionsList();
        //jslog("i", "global.siteUrl" + global.siteUrl);
        if (typeof global.siteUrl === "undefined") {
            jslog("e", "global.siteUrl undefined");
        }
        loadQuestionSuggestions();
        setSuggestedQuestions();
    } catch (e) {
        jslog("e", "onDeviceReady 1" + dumpvar(e));
    }
    try {
        // demo
        if (0) {
            test_formatAnswer("question_examples");
            return;
        }
        //jslog("i", "ondevice 1");
        if (device.platform == 'android' || device.platform == 'Android') {
            if (typeof CameraSW !== "undefined") {
                //jslog("i","getCameraResolution = " + CameraSW.getCameraResolution());
            }
            androidNotifications();

        } else if (isIOS()) {
            //jslog("i", "iosNotifications" + typeof iosNotifications);
            if (typeof iosNotifications == "function")
                iosNotifications();
        } else {
            //jslog("i", "no notifications for " + device.platform);
        }

        global.sid = getSid();
    } catch (e) {
        jslog("e", "onDeviceReady notifications" + dumpvar(e));
    }
    try {
        // just incase network takes a long time update the questions list right
        // away
        // maybe no force update now, as if there is changes update will
        // run call back
        //jslog("i", "ondevice 2");
        document.addEventListener("resume", resumeupdateQuestions, false)
        //jslog("i", "ondevice 3");
        if (isAndroid()) {
            document.addEventListener("backbutton", hwkhlp_back, false);
            //document.addEventListener("menubutton", hwkhlp_menu, false);
            //document.addEventListener("backbutton", goback, false);
            //document.addEventListener("menubutton", gomenu, false);
        }
        //if (global.beta != true)
        setTimeout(pagerendered, 500);
        //jslog("i", "ondevice 4");
        textarearesize_hwkhlp();
        //jslog("i", "ondevice 5");
        if (!isRipple())
            if (typeof registerPayments == "function")
                registerPayments();
            //jslog("i", "ondevice 6");
    } catch (e) {
        jslog("e", "onDeviceReady registerPayments" + dumpvar(e));
    }

    try {
        generateQuestionUuid();
        //jslog("i", "ondevice 7");
        initQuestionForSudent();
        //jslog("i", "ondevice 8" + JSON.stringify(global.question_for_student));
        global.question_count = window.localStorage.getItem("question_count");
        if (typeof global.question_count === "undefined" || global.question_count == null)
            global.question_count = 0;
    } catch (e) {
        jslog("e", "onDeviceReady question setup" + dumpvar(e));
    }
    try {
        processUploadQueue();
        // disable access pro
        //if (isAndroid())
        //	for (i = 0; i < 2; i++)
        //		hideDiv("access_pro" + i);
    } catch (e) {
        jslog("e", "onDeviceReady 3" + dumpvar(e));
    }
    try {
        var resume = window.localStorage.getItem("resume_page");
        jslog("i", "onDeviceReady resume_page =" + resume);
        if (resume != null) {
            switch (resume) {
                case "newQuestion":
                    switchMain("indexpage");
                    break;
                case "lessonslist":
                    lessonsList();
                    break;
                case "questionsforuser":
                    showQuestionsForUser();
                    break;
                case "lesson_listpage":
                    lessonsList();
                    break;
                case "questionpage":
                    myQuestions();
                    break;
                case "lesson_selecttopicpage":
                default:
                    var pattern = new RegExp("^lesson_", "i");
                    if (pattern.test(resume)) {
                        var t = window.localStorage.getItem("global.current_lesson_count");
                        if (t != null) {
                            global.current_lesson_count = t;
                            getLesson(t);
                        }
                        setUploadName(resume);
                        updateLessonPreview(resume + "page");
                        if (resume == "lesson_selecttopic")
                            lessonAskToSelectTopic();
                        else
                            myQuestions();
                    } else {
                        switchMain("indexpage");
                    }

            }
        } else {
            try {
                // generate question uuid early so that camera can access
                newQuestion();
            } catch (e) {
                jslog("e", "onDeviceReady 4" + dumpvar(e));
            }
        }
    } catch (e) {
        jslog("e", "onDeviceReady 5" + dumpvar(e));
    }

    lessonCheckIfMoreNeeded();

}



function initDBv1() {
    //jslog("i", "starting initDBv1 adding test data");
    db = window.openDatabase("questions", "1.0", "Questions", 100000);
    new query(
        'CREATE TABLE IF NOT EXISTS QUESTIONS (id INTEGER PRIMARY KEY, questionfile varchar(255),questionid int, description Blob,total_answers int,since_time_answers int,created varchar(20))');
    for (i = 1; i < 20; i++)
        new query("INSERT INTO QUESTIONS (questionid, questionfile, description,created) VALUES (?,?,?,?)", [i,

            "questionfileURI" + i, "description" + i, "created" + i,
        ]);
}

function createV2Tablestx(tx) {
    //do initial setup
    //jslog("i", 'initDB do initial create v2.0 ');
    try {
        new queryDB(
            tx,
            'CREATE TABLE IF NOT EXISTS QUESTIONSV2 (id INTEGER PRIMARY KEY, questionfile varchar(255),questionid int,question_uuid varchar(255), description Blob,full_answer Blob,total_answers int,since_time_answers int,created varchar(20),createdint int)', [], function(tx) {
                copyV1TOV2(tx);
                //window.localStorage.setItem("db_version", "2.0");
                //jslog("i", "setting db_version 1");
            });
    } catch (e) {
        jslog("e", "changeVersion: " + e + " " + dumpvar(e));
        return false;
    }
}

function createV2Tables(copy) {
    new query(
        'CREATE TABLE IF NOT EXISTS QUESTIONSV2 (id INTEGER PRIMARY KEY, questionfile varchar(255),questionid int,question_uuid varchar(255), description Blob,full_answer Blob,total_answers int,since_time_answers int,created varchar(20),createdint int)', [], function(tx) {
            if (copy)
                copyV1TOV2(tx);
            else
                copyQuestionsv2toassoc();
            //window.localStorage.setItem("db_version", "2.0");
            //jslog("i", "setting db_version 2");
        });
}

function copyV1TOV2(tx) {
    try {
        //jslog("i", "copyV1TOV2 start");
        new queryDB(tx, "SELECT * FROM QUESTIONS", [], function(tx, results) {

            try {
                var len = results.rows.length;
                //jslog("i", "copyV1TOV2 len " + len);
                if (len > 0) {
                    //if (01)
                    //jslog("i", "copyV1TOV2 1: v1 v2 len" + len);
                    // prevents huge question lists
                    c = 0;
                    ids = "";
                    //for ( var i = len - 1; i >= 0 && (c < 10); i--) {
                    for (var i = 0; i < len; i++) {
                        c++;
                        /*jslog("i", "updateQuestionsQuery: id:" + results.rows.item(i).questionid + " total_answers:"
									+ results.rows.item(i).total_answers + " des:" + results.rows.item(i).description + " file:"
									+ results.rows.item(i).questionfile + " isImage:" + isImage(results.rows.item(i).questionfile));
									*/
                        // compile list of ids
                        new addNewQuestion(results.rows.item(i), true);
                        //query("INSERT INTO QUESTIONSV2 ")
                    }
                }
            } catch (e) {
                jslog("e", "copyV1TOV2 2 upgrade 1.0 to 2.0 error : " + e + " " + dumpvar(e));
            }

        });
        /*
		 * ,function (e,e1) {
			jslog("e","copyV1TOV2:")
		}
		 */
    } catch (e) {
        jslog("e", "copyV1TOV2 3 upgrade 1.0 to 2.0 error : " + e + " " + dumpvar(e));
    }
}

function upgradeV1TOV2() {
    //jslog("i", "database upgrade v1 to v2 db");

    try {
        //jslog("i", "database upgrade v1 to v2 db: copy data from v1 to v2");
        db.changeVersion("1.0", "2.1", function(tx) {
                //jslog("i", "initDB upgrade 1.0 to 2.0 ");
                createV2Tables(true);

            },
            //used for error
            function(e) {
                //jslog("i", 'initDB error in changeV upgrade 1.0 to 2.0');
                //jslog("i", 'initDB error ' + JSON.stringify(e));
            },
            //used for success
            function() {
                //jslog("i", 'initDB upgrade 1.0 to 2.0 success db=' + db.version);
            });
    } catch (e) {
        jslog("e", "error initDB upgrade 1.0 to 2.0" + e + " " + dumpvar(e));
    }
}

function initDB() {
    var debug = false;
    //if (debug) 
    jslog("i", "starting initDB");
    //	db = window.openDatabase("questions", "1.0", "Questions", 100000);
    try {
        db = window.openDatabase("questions", "", "Questions", 100000);
        //jslog("i", "database version " + db.version + " " + typeof db.version);
        //		db_version = window.localStorage.getItem("db_version");
        //		if (db_version == null)
        //			db_version = "";
        //jslog("i","db.version " + typeof db.version);
        //jslog("i","changeVersion " + typeof db.changeVersion);

        //not sure if this is needed
        //db_version = window.localStorage.getItem("db_version");
        //jslog("i", "initDB: db_version 1 = " + db_version);
        //if (db_version == null || db_version == "") {
        //	db_version = db.version;
        //}
        db_version = db.version;
        if (debug)
            jslog("i", "initDB: db_version = " + db_version);
        if (db_version == "") {
            var go = false;
            try {
                db.changeVersion("", "2.1", function(tx) {
                    createV2Tables();
                });
            } catch (e) {
                go = true;
                // db failure trying two arg version
                if (debug) jslog("i", "initDB error trying 2 arg version " + JSON.stringify(e));
            }
            if (go) {
                try {
                    //			db.changeVersion("", "2.0");
                    createV2Tables();
                } catch (e) {
                    jslog("e", "initDB error 2 arg version failed as well " + JSON.stringify(e));
                }
            }
        } else if (db_version == "1.0") {
            upgradeV1TOV2();
        } else if (db_version == "2.0") {
            if (debug) jslog("i", 'initDB im a 2.0 user');
            try {
                // this is only needed to accomidate addNewQuestion which does not check to see
                // if field does not exists 
                db.changeVersion("2.0", "2.1", function(tx) {
                        if (debug)
                            jslog("i", "initDB upgrade 2.0 to 2.1 ");
                        try {
                            tx.executeSql("ALTER TABLE QUESTIONS ADD COLUMN question_uuid varchar(255)", [], function() {
                                jslog("i", "initDB 2.0 to 2.1 success 1");
                            }, function(e) {
                                errorCB(e, "initDB 2.0 to 2.1 error 2")
                            });
                            tx.executeSql("ALTER TABLE QUESTIONS ADD COLUMN createdint int", [], function() {
                                jslog("i", "initDB 2.0 to 2.1 success 2");
                            }, function(e) {
                                errorCB(e, "initDB 2.0 to 2.1 error 2")
                            });
                        } catch (e) {
                            jslog("e", "initDB upgrade 2.0 to 2.1 error : " + e + " " + dumpvar(e));
                        }
                        copyQuestionsv2toassoc();

                    },
                    //used for error
                    function(e) {
                        if (debug) jslog("i", 'initDB error in changeV upgrade 2.0 to 2.1');
                        if (debug) jslog("i", 'initDB error ' + JSON.stringify(e));
                    },
                    //used for success
                    function() {
                        if (debug) jslog("i", 'initDB upgrade 2.0 to 2.1 success db=' + db.version);
                    });
            } catch (e) {
                jslog("e", "initDB upgrade 2.0 to 2.1" + e + " " + dumpvar(e));

            }
        } else {
            copyQuestionsv2toassoc();
            //updateQuestions();	
        }


    } catch (e) {
        jslog("e", "initDB error " + JSON.stringify(e));
    }
}

function copyQuestionsv2toassoc() {
    try {
        jslog("i", "sql2assoc: start");
        db.transaction(sql2assoc, function(e) {
            errorCB(e, "initDB 1")
        }, successCB);
    } catch (e) {
        jslog("e", "copyQuestionsv2toassoc error " + JSON.stringify(e));
    }
}
/* to add a new div to a page create textarea0 to textarea2

*/
function add_textarearesize_functions(i) {
    check1 = document.getElementById('textareadiv' + i);
    check2 = document.getElementById('textarea' + i);
    if (check1 == null || check2 == null) {
        return false;
    }
    try {
        (function() {
            var c = document.getElementById('textareadiv' + i);
            var t = document.getElementById('textarea' + i);
            var f = document.createTextNode('');
            if (c != null) {
                c.appendChild(f);
                //var updateSize = function() {
                //	f.nodeValue = t.value + '\n\n';
                //}
                var updateSize1 = function() {
                    f.nodeValue = t.value + '\n';
                }
                t.onkeypress = t.onkeyup = t.onchange = updateSize1;
                updateSize1();
            }
        })();
        return true;
    } catch (e) {
        jslog("e", "textarearesize " + JSON.stringify(e));
    }

}

function textarearesize_hwkhlp() {
    try {
        for (i = 0; i < 2; i++) {
            if (!add_textarearesize_functions(i)) {
                jslog("e", "textarearesize_hwkhlp: textarea" + i + ":missing");
            };
        } //for
        // ,
        var textareas = ["question_message", "lesson_answers", "lesson_description", "lesson_other", "lesson_steps", "lesson_videos"];
        for (i = 0; i < textareas.length; i++) {
            if (!add_textarearesize_functions(textareas[i]))
                jslog("e", "textarearesize not found:" + textareas[i]);
        } //for
    } catch (e) {
        jslog("e", "textarearesize " + JSON.stringify(e));
    }
}

function resumeupdateQuestions() {
    try {
        jslog("d", "resumeupdateQuestions:" + global.noupdate);
        if (global.noupdate) {
            global.noupdate = false
        } else {
            updateQuestions();
        }
    } catch (e) {
        jslog("e", "resumeupdateQuestions " + JSON.stringify(e));
    }
}

function updateQuestions() {
    try {
        jslog("d", "updateQuestions:");
        global.noupdate = false;
        //if (isUpdating)
        //	return;
        global.isUpdating = true;
        setDivHTML("update_questions", "Updating Please wait...");
        showDiv("update_questions");
        setDivHTML("update_questions1", "Updating Please wait...");
        showDiv("update_questions1");

        global.force_update = true;
        updateQuestionsQuery(global.questions);
    } catch (e) {
        jslog("e", "updateQuestions " + e + " " + JSON.stringify(e));
    }
    processUploadQueue();
}

function updateQuestionsQuery(results) {
    try {
        var len = results.length;
        if (len > 0) {
            //if (0)
            //jslog("i", "updateQuestions: len" + len);
            // prevents huge question lists
            c = 0;
            ids = "";
            //for ( var i = len - 1; i >= 0 && (c < 10); i--) {
            for (var i = 0; i < len; i++) {
                c++;
                /*if (0)
					jslog("i", "updateQuestionsQuery: id:" + results[i].questionid + " total_answers:" + results[i].total_answers
							+ " des:" + results[i].description + " file:" + results[i].questionfile + " isImage:"
							+ isImage(results[i].questionfile));*/
                // compile list of ids
                ids += results[i].questionid + ",";
            }
            // send get request for question json
            //jslog("i","updateQuestionsQuery ids:" + ids);
            http_get_questions(ids);
            // itlerate threw json to update data
        } else {
            updateQuestionCompleted();
        }
    } catch (e) {
        jslog("e", "updateQuestionsQuery " + e + " " + JSON.stringify(e));
    }
}

function setQuestionStats() {
    var len = global.questions.length,
        c = 0;
    global.stats = {};
    try {
        for (var i = len - 1; i >= 0; i--) {
            c++;
            // && (c < 10)
            var qid = 0;
            /*	if (0)
						jslog("i", "updateQuestionsQuery: i = " + i + " id:" + global.questions[i].questionid + " ans:"
								+ global.questions[i].total_answers + " des:" + global.questions[i].description + " file:"
								+ global.questions[i].questionfile + " isImage:" + isImage(global.questions[i].questionfile));
*/
            // compile list of current global.stats
            if (typeof global.questions[i].total_answers === "undefined")
                global.questions[i].total_answers = 0;
            if (typeof global.questions[i] !== "undefined" && typeof global.questions[i].questionid !== "undefined") {
                qid = global.questions[i].questionid;
            } else {
                jslog("e", "	findUpdated undefined typeof global.questions[i] " + typeof global.questions[i])
                jslog("e", "	findUpdated undefined typeof global.questions[i].questionid " + typeof global.questions[i].questionid)
            }
            if (qid > 0) {
                global.stats[qid] = {};
                global.stats[qid]['total_answers'] = global.questions[i].total_answers;
                global.stats[qid]['total_flags'] = global.questions[i].total_flags;
            }
        }
    } catch (e) {
        jslog("e", "findUpdated: for loop" + e.message);
    }
}

function findUpdated() {
    try {
        if (typeof results === "undefined") {
            //jslog("i", "findUpdated error " + printStackTrace());
        }
        var len = global.questions.length;
        if (global.data_update == null) {
            return false;
        }
        // records that need updating
        var data_to_update = new Array();

        if (len > 0) {
            //jslog("i", "updateQuestions: len" + len);
            // prevents huge question lists
            ids = "";
            setQuestionStats();
            var unseen_question_list = getUnseenQuestions();
            // cycle from the data source as it's more likely to contain records
            // not in app's internal memory, ie broadcast message
            var hasnotifications = false;
            count = 0;
            try {
                for (var qid in global.data_update) {
                    count++;
                    var obj = global.data_update[qid];
                    //jslog("i", "updateQuestionsData: qid=" + qid
                    //		+ ":total_answers=:" + obj['total_answers']);
                    if (typeof global.stats === "undefined" || global.stats == null)
                        global.stats = {};
                    if (typeof global.stats[qid] === "undefined")
                        global.stats[qid] = 0;
                    // if total_answers != last total answers then add to notication list
                    if (typeof global.stats !== "undefined" && global.stats != null && typeof global.stats[qid] !== "undefined") {


                        if (global.stats[qid]['total_answers'] != obj['total_answers'] && obj['total_answers'] > 0)
                            jslog("i", "updateQuestionsData:" + qid + ":old:" + global.stats[qid]['total_answers'] + ":new:" + obj['total_answers']);
                        changed = false;
                        if (global.stats[qid]['total_answers'] != obj['total_answers'] && obj['total_answers'] > 0) {
                            changed = true;
                        }
                        if (global.stats[qid]['total_flags'] != obj['total_flags'] && obj['total_flags'] > 0) {
                            changed = true;
                        }

                        if (global.stats[qid]['total_answers'] != obj['total_answers'] && obj['total_answers'] > 0) {
                            hasnotifications = true;
                            // change sense last update add to questions_list

                            //jslog("i", "updateQuestionsData: new answer " + qid + ":" + obj['question'] + ":" + obj['message'])

                            try {
                                unseen_question_list[qid] = {
                                    questionid: qid,
                                    question_uuid: obj['question_uuid'],
                                    description: obj['question'],
                                    answer: obj['message'],
                                    questionfileURI: "",
                                    total_answers: obj['total_answers'],
                                    total_flags: obj['total_flags']
                                };
                            } catch (e) {
                                jslog("e", "findUpdated: for loop 1" + e.message + " m = " + dumpvar(e));
                            }
                            //							unseen_question_list[qid] = [ qid, obj['question'], obj['message'],obj['total_answers'] ];
                        }
                    }
                    try {
                        //jslog("i", "findUpdated 6 = " + qid);
                        data_to_update.push(obj);
                    } catch (e) {
                        jslog("e", "findUpdated: for loop 1" + e.message + " m = " + dumpvar(e));
                    }
                }
            } catch (e) {
                jslog("e", "findUpdated: for loop 1" + e.message + " m = " + dumpvar(e));

            }
            /*
             */
            // all this just to get the updateQuestionsList function to call on the
            // last call back for the update query, what a pain in the ass
            // (the need was caused by using sqllite but that was dropped...so
            // now the code could be simplified...
            last = 0;
            update_count = 0;
            try {
                for (i = 0; i < count; i++) {
                    if (typeof data_to_update[i] !== "undefined") {

                        obj = data_to_update[i];
                        last = 0;
                        if ((i + 1) == count) {
                            last = 1;
                        }
                        // last calls updateQuestionsList to update my questions list
                        try {
                            if (obj['total_answers']) {
                                update_count++;
                                updateQuestion(obj, last);
                            } else if (last) {
                                updateQuestionsList();
                            }
                        } catch (e) {
                            jslog("e", "findUpdated: for loop 2a" + e.message);
                        }
                    } else {
                        //                alert(" data_to_update error " + i );
                        jslog("e", "data_to_update_error" + i + " " + data_to_update);
                    }

                }
            } catch (e) {
                jslog("e", "findUpdated: for loop 2" + e.message);
            }

            if (hasnotifications) {
                //jslog("i", "findUpdated: hasnotifications " + dumpvar(unseen_question_list));
                updateNotificationList(unseen_question_list);
                updateQuestionsList();
            }
            //jslog("i", "findUpdated: updates sent")
            //jslog("i", "findUpdated: update_count:" + update_count + " last " + last);
        } else {}
    } catch (e) {
        jslog("e", "findUpdated error" + e + " " + dumpvar(e));
    }
}

function updateQuestionsList() {
    showQuestionsAssoc();

}

function clearQuestions() {
    if (typeof db != "undefined") {
        try {
            db.transaction(function(tx) {
                tx.executeSql('DELETE FROM QUESTIONS');
            });
        } catch (e) {
            jslog("e", "clearQuestions " + e + " " + JSON.stringify(e));
        }
        try {
            db.transaction(function(tx) {
                tx.executeSql('DELETE FROM QUESTIONSV2');
            });
        } catch (e) {
            jslog("e", "clearQuestions " + e + " " + JSON.stringify(e));
        }
    }
    window.localStorage.clear();
}



function setQuestionData(data) {
    try {
        if (typeof data['questions_for_student'] !== "undefined")
            addQuestionsToUnanswered(data);
    } catch (e) {
        jslog("e", "setQuestionData " + e + " " + JSON.stringify(e));
    }

    try {
        // set questionid only if question_uuid has not changed in the mean time
        if (typeof data['question_id'] !== "undefined" && typeof data['question_uuid'] !== "undefined" && global.question_uuid == data['question_uuid']) {
            global.questionid = data['question_id'];
        } else {
            //jslog("i", "setQuestionData questionid not set: current question_uuid " + global.question_uuid + " data = " + dumpvar(data)
            //					+ "current upload " + dumpvar(global.upload_queue[0]));
            if (typeof data['error'] !== "undefined") {
                centerMessage("Error:" + data['error'], 0);
                return false;
            }
        }
    } catch (e) {
        jslog("e", "setQuestionData " + e + " " + JSON.stringify(e));
    }

    if (typeof data['sid'] !== "undefined") {
        //jslog("i", "setQuestionData sid from response:" + data['sid'])
        setSid(data['sid']);
        //jslog("i", "setQuestionData sid after setSid:" + sid);
        // getSid();
        //jslog("i","setQuestionData getSid / test retrieve from db:"+);
        //jslog("i","setQuestionData sid after test getSid:" + sid);
    }
    return true;
}

function uploadQuestionSuccess(data) {
    /*	jslog("i", "uploadQuestionSuccess current question_uuid " + global.question_uuid + " data = " + dumpvar(data) + "current upload "
			+ dumpvar(global.upload_queue[0]));*/
    new addNewQuestion(data);
}

function addNewQuestion(data, mode) {
    var self = this;
    if (typeof mode === "undefined")
        mode = false;
    try {

        if (mode) {
            fields = "questionid,question_uuid,questionfile,description,created,createdint";
            fieldsa = fields.split(",");
            for (i = 0; i < fieldsa.length; i++) {
                id = fieldsa[i];
                if (typeof data[id] !== "undefined")
                    this[id] = data[id];
                else this[id] = null;
            }
            if (objectHasValue(data, 'createdint')) {
                this.createdint = d.getTime();
                this.created = d.toDateString();
            }
            this.questionfileURI = self.questionfileURI;
            var d = new Date();
            if (typeof data.question_uuid === "undefined")
                this.question_uuid = data.questionid + "_" + d.getTime();
            /*
			if (typeof data.questionfile !== "undefined")
			this.questionfileURI = data.questionfile;
			if (typeof data.description !== "undefined")
			this.description = data.description;*/
        } else {
            var d = new Date();
            this.createdint = d.getTime();
            this.created = d.toDateString();
            if (typeof global.upload_queue[0] !== "undefined") {
                current_add = global.upload_queue[0];
                this.question_uuid = current_add.question_uuid;
                this.questionfileURI = current_add.questionfileURI;
                this.description = current_add.message;
            }
            this.questionid = data.question_id;
            this.id = data.question_id; //for updatequestin( 
        }

        this.addQuestion = function() {
            updateGlobalQuestion({
                questionid: self.questionid,
                question_uuid: self.question_uuid,
                questionfileURI: self.questionfileURI,
                description: self.description,
                created: self.created,
                createdint: self.createdint
            });
        }
        this.addQuestion();
        updateQuestionsList();
    } catch (e) {
        jslog("e", "addNewQuestion:" + e + " " + dumpvar(e) + " self = " + dumpvar(self));
    }

}



function checkIfFileExists(path, fileDoesNotExist, fileExists) {
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
        fileSystem.root.getFile(path, {
            create: false
        }, fileExists, fileDoesNotExist);
    }, getFSFail); //of requestFileSystem
}
/*
function fileExists(fileEntry){
    alert("File " + fileEntry.fullPath + " exists!");
}
function fileDoesNotExist(){
    alert("file does not exist");
}*/
function getFSFail(evt) {
    //jslog("i", evt.target.error.code);
}

function onPhotoURISuccessiOS(imageURI) {
    // this relies on knowledge of photo file URI - you might
    //want to make this more robust :-)
    var imgFileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
    var imgPath = "tmp/" + imgFileName;
    //jslog("i", "onPhotoURISuccessiOS: imgfilename = " + imgFileName);
    //resolve file system for image
    //(image is currently stored in dir off of persistent file
    //system but that may change)
    var destinationFile = getQuestionFileName(imgFileName);
    var exists = new fileExists(destinationFile,
        // file exists start
        function(fileEntry) {
            //jslog("i", "file exists" + fileEntry.fullPath + " destinationFile:" + destinationFile);
            fileEntry.remove(function(entry) {
                //jslog("i", "file remove successfull");
                copy = new copyFileToPersistent(imageURI, destinationFile, copiedFile);
                copy.copy();
            }, function(e) {
                //jslog("i", "file remove failed" + e);
            });
        }
        // file exists end
        ,

        function() {
            //jslog("i", "file DOES NOT exist" + destinationFile);
            copy = new copyFileToPersistent(imageURI, destinationFile, copiedFile);
            copy.copy();
        });
    exists.check();
}

function copiedFile(fileEntry) {
    var url = null;
    if (isIOS()) {
        url = fileEntry.nativeURL;
    } else {
        url = fileEntry.toURL();
    }
    //copiedfilepath = fileEntry;
    jslog("i", "onPhotoURISuccessiOS: copiedFile: copied file: " + fileEntry.fullPath);
    // !!! assumes you have an img element on page with
    if (global.current_page == "editpage")
        setQuestionImage(url);
    else
        setQuestionImage(url);
    setUploadFile(url);
    //jslog("i", "copiedFile new questionfileURI " + fileEntry.toURL());
    navigator.camera.cleanup(function() {
        //jslog("i", "camera.cleanup: success");
    }, function(e) {
        //jslog("i", "camera.cleanup: fail:" + e);
    });
}

function uploadRemoveImage(n) {
    if (typeof global.image[n] !== "undefined")
        global.image[n] = null;
    if (n == "smallImage" || n == "editsmallImage")
        global.questionfileURI = null;
    setQuestionImage(null);
    //	smallImage = document.getElementById('smallImage');
}

// Get image handle

function setQuestionImage(imageURI, upload_name) {
    try {
        //jslog("i", "smallImage" + imageURI + " current_page: " + global.current_page + "upload name = " + global.upload_name);
        var smallImage = null;
        var name = null;
        if (global.current_page == "editpage" || upload_name == "editimageSmall") {
            name = 'editsmallImage';
        } else if (typeof upload_name !== "undefined" && upload_name != null) {
            name = upload_name + "_image";
        } else {
            if (global.current_page == "indexpage") {
                name = 'smallImage';
            } else if (typeof global.upload_name == "string" && global.upload_name != "" && global.upload_name != null) {
                upload_name = global.upload_name;
                name = global.upload_name + "_image";
            }
        }
        smallImage = document.getElementById(name);

        if (smallImage != null) {
            // smallImage.src = imageURI;
            if (imageURI != null) {
                //addRandomUriString
                smallImage.src = (imageURI);
                smallImage.style.margin = "3px auto 3px auto";
                smallImage.style.height = "60px";
                smallImage.style.border = "1px solid gray"
                smallImage.style.display = "block";
                showDiv(name + "_remove");
            } else {
                smallImage.src = "./images/1x1.png";
                smallImage.style.height = "1px";
                smallImage.style.display = "none";
                smallImage.style.border = "none";
                hideDiv(name + "_remove");
            }
        } else {
            if (typeof global.upload_name == "string") {
                jslog("e", "smallImage = null" + imageURI + " current_page: " + global.current_page + "upload name = " + global.upload_name + " name = " + name);
            } else
                jslog("e", "smallImage = null" + imageURI + " current_page: " + global.current_page + " name = " + name);
        }
    } catch (e) {
        jslog("e", "setQuestionImage: " + dumpvar(e));
    }
}

function setEditQuestionImage(imageURI) {
    setQuestionImage(imageURI);
}

function fsFailresolveLocalFileSystemURI(error) {
    //jslog("i", "onPhotoGalleryURISuccess resolveLocalFileSystemURI failed with error code: " + error.code);
}

function setUploadFile(filelocation) {
    //jslog("i", "setUploadFile=" + filelocation + "upload_name =" + global.upload_name);
    if (typeof global.image === "undefined")
        global.image = {}
    if (typeof global.upload_name == "string") {
        global.image[global.upload_name] = filelocation;
        //jslog("i", "setUploadFile:image[upload_name] =" + global.image[global.upload_name]);
    } else {
        global.questionfileURI = filelocation;
    }
}

function onPhotoGalleryURISuccess(imageURI) {
    try {
        jslog("i", "onPhotoGalleryURISuccess: " + imageURI);

        var filelocation = null;
        // var image_count = getNextImage();
        var gotFileEntry = function(fileEntry) {
            jslog("i", "onPhotoGalleryURISuccess: got image file entry: " + fileEntry.fullPath);
            if (isIOS()) {
                filelocation = fileEntry.toURL();
            } else
                filelocation = fileEntry.fullPath;
            setUploadFile(filelocation);

            jslog("i", "onPhotoGalleryURISuccess: imageURI = " + imageURI + " questionfileURI = " + filelocation + " upload_name = " + global.upload_name);
            setQuestionImage(filelocation);
        };
        // resolve file system for image
        if (typeof window.resolveLocalFileSystemURL === "undefined")
            window.resolveLocalFileSystemURI(imageURI, gotFileEntry, fsFailresolveLocalFileSystemURI);
        else
            window.resolveLocalFileSystemURL(imageURI, gotFileEntry, fsFailresolveLocalFileSystemURI);
    } catch (e) {
        jslog("e", "onPhotoGalleryURISuccess error: " + e + " " + dumpvar(e));
    }

}

function onPhotoURISuccess(imageURI) {
    jslog("i", "onPhotoURISuccess: " + imageURI + "global.upload_name = " + global.upload_name);
    // if someone uploaded, removed and then uploaded, remove the remove request
    // reset remove to prevent delete
    // current order is update image, then update description which has piggy backed remove command
    global.removeimages = [];

    if (objectHasValue(global, 'upload_name')) {
        if (typeof global.removeimages !== "undefined") {
            n = global.upload_name;
            // if currently uploading old image then stop
            global.lesson[n + '_uploading'] = false;
            if (contains(global.removeimages, n)) {
                var t = [];
                for (i = 0; i < global.removeimages.length; i++)
                    if (global.removeimages[i] != n)
                        t.push(global.removeimages[i]);
                global.removeimages = t;
            }
        }
    }
    if (isIOS()) {
        return onPhotoURISuccessiOS(imageURI);
    }
    //android
    if (0) {
        global.questionfileURI = imageURI;
        //jslog("i", "onPhotoURISuccess: set imageURI = " + imageURI + " questionfileURI = " + global.questionfileURI);
        return setQuestionImage(imageURI);
    }
    var filelocation = null;
    // var image_count = getNextImage();
    var gotFileEntry = function(fileEntry) {
        jslog("i", "onPhotoURISuccess: got image file entry: " + fileEntry.fullPath);
        filelocation = fileEntry.nativeURL;
        setUploadFile(filelocation);
        jslog("i", "onPhotoURISuccess: imageURI = " + imageURI + " questionfileURI = " + filelocation + " dumpvar = " + dumpvar(fileEntry));
        setQuestionImage(filelocation);
    };
    // resolve file system for image
    if (typeof window.resolveLocalFileSystemURL === "undefined")
        window.resolveLocalFileSystemURI(imageURI, gotFileEntry, fsFailresolveLocalFileSystemURI);
    else
        window.resolveLocalFileSystemURL(imageURI, gotFileEntry, fsFailresolveLocalFileSystemURI);
    // localimage = "question_" + image_count + ".jpg";
    // option 1 send one image
    // need to show thumb nail of image
    // if someone wants to change image they will need to take a new one
    // or will need a delete/remove button

    // option 2 send more then one image
    // need code here to show pannel which collects images
    // images need option to remove as well
    // send all images to server once done
    // largeImage.style.display = 'block';

    // Show the captured photo
    // The inline CSS rules are used to resize the image
    //
}

function getQuestionFileName(file) {
    return global.question_uuid + "." + getFileExtension(file);
}

function submitform(edit) {
    try {
        if (typeof edit !== "undefined" && edit)
            id = document.getElementById("textarea1");
        else
            id = document.getElementById("textarea0");
        global.description = id.value;
        var pattern = new RegExp("^[a-z0-9]+$", "i");
        /*	  jslog("i", "submitform question_uuid = " + global.question_uuid + " description = " + global.description + " regex "
				+ pattern.test(global.description));*/
        if ((global.questionfileURI == null || global.questionfileURI == "") && (global.description == null || global.description == "")) {
            centerMessage("Please take a photo of your question or enter it in the box", 0);
            return false;
        }
        if (global.questionfileURI == null && pattern.test(global.description)) {
            centerMessage("What you entered does not look like a question, Please take a photo of your question or enter it in the box", 0);
            return false;
        }

        //jslog("i", "submitform qfUIR = " + global.questionfileURI + " ds = " + global.description);
        var fail, ft, options, param, win;
        param = {
            action: "upload_question",
            message: global.description,
            questionfileURI: global.questionfileURI,
            question_uuid: global.question_uuid
        };
        if (typeof global.isloading !== "undefined" && global.isloading) {
            showHover();
        }
        try {
            //jslog("i", "addUploadQueue submitform");
            addUploadQueue(param);
        } catch (e) {
            jslog("e", "submitform() 2: " + e + " " + dumpvar(e));
        }
    } catch (e) {
        jslog("e", "submitform() 1: " + e + " " + dumpvar(e));
    }
    global.upload_count = global.upload_count * 1 + 1;
    global.question_count = global.question_count * 1 + 1;
    window.localStorage.setItem("question_count", global.question_count);
    try {
        processUploadQueue();
    } catch (e) {
        jslog("e", "submitform() 2a: " + e + " " + dumpvar(e));
    }
    try {
        initQuestionForSudent();
    } catch (e) {
        jslog("e", "submitform() 2: " + e + " " + dumpvar(e));
    }
    try {
        global.question_for_student.answered_questions_count = 0;
    } catch (e) {
        jslog("e", "submitform() 2: " + e + " " + dumpvar(e));
    }
    try {
        // loading is now done in the background
        if ((global.questionfileURI != null && global.questionfileURI != "") && (global.description != null && global.description != "")) {
            // use if want to ask for description on image only upload
            /*			var ask_description = {
					"id" : "6",
					"question" : "<span class=\"question_text\">What subject is your question ?<\/span>"
							+ "\n<input type=\"text\" class=\"question_text\" name=\"subject\" id=\"subject\" />\n",
					"fields" : "question_text"
				};
				*/
            // image and now question
            //global.question_for_student.unanswered_questions.push(ask_description);
            //showQuestionsForUser();
            //myQuestions();
            askQuestionSubject();
        } else {
            //			showQuestionsForUser();
            askQuestionSubject();
            //			askCreateLesson();
            //myQuestions();
        }
    } catch (e) {
        jslog("e", "submitform() 3: " + e + " " + dumpvar(e));
    }
}

function uploadQuestion(param) {
    //jslog("i", "uploadQuestion: " + dumpvar(param));
    if (typeof param['questionfileURI'] === "undefined")
        param['questionfileURI'] = null;
    if (param['questionfileURI'] != null && param['questionfileURI'] != "") {
        // callback for when the photo has been successfully uploaded:
        options = new FileUploadOptions();
        // parameter name of file:
        options.fileKey = "questionfile";
        options.mimeType = "text/plain";
        options.mimeType = "image/jpeg";
        // name of the file:
        options.fileName = getQuestionFileName(global.questionfileURI);

        // mime type:

        options.params = param;

        ft = new FileTransfer();
        setIsLoading();
        showHover();
        ft.onprogress = genericOnprogress;
        if (0) // progress indicator is disabled
            ft.onprogress = function(progressEvent) {
            statusDom = document.getElementById("percent");
            //jslog("i", "progress:" + progressEvent.lengthComputable);
            if (progressEvent.lengthComputable) {
                //jslog("i", "progress:" + progressEvent.loaded + "/" + progressEvent.total);
                var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
                statusDom.innerHTML = perc + "%";
            } else {
                if (statusDom.innerHTML == "") {
                    statusDom.innerHTML = ".";
                } else {
                    statusDom.innerHTML += ".";
                }
            }
        };
        ft.upload(param['questionfileURI'], global.siteUrl + '/app_' + global.app_version + '_upload', uploadsuccess, uploadfail, options);
    } else {
        sendPost(global.siteUrl + '/app_' + global.app_version + '_upload', param, 1);
    }
}

function initQuestionForSudent() {
    try {
        // reset counters as this is a new question submit
        if (global.question_for_student == null || typeof global.question_for_student === "undefined") {

            t = window.localStorage.getItem("global.questions_cache");
            if (t != null && typeof t == "string") {
                global.questions_cache = JSON.parse(t);
            } else {
                global.questions_cache = {};
                global.questions_cache['3'] = {
                    "id": "3",
                    "hide_answer_button": "1",
                    "question": "    <input type=\"hidden\" id=\"school_grade\" name=\"school_grade\" value=\"\" \/> <span class=\"question_text\"> What grade are you in ?<\/span>\n    <div class=\"centerquestions\">\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','13')\" class=\"bf_button_large0 questionbutton\"><span>Grade 13<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','12')\" class=\"bf_button_large0 questionbutton\"><span>Grade 12<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','11')\" class=\"bf_button_large0 questionbutton\"><span>Grade 11<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','10')\" class=\"bf_button_large0 questionbutton\"><span>Grade 10<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','9')\" class=\"bf_button_large0 questionbutton\"><span>Grade 9<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','8')\" class=\"bf_button_large0 questionbutton\"><span>Grade 8<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','7')\" class=\"bf_button_large0 questionbutton\"><span>Grade 7<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','6')\" class=\"bf_button_large0 questionbutton\"><span>Grade 6<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','5')\" class=\"bf_button_large0 questionbutton\"><span>Grade 5<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','4')\" class=\"bf_button_large0 questionbutton\"><span>Grade 4<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','3')\" class=\"bf_button_large0 questionbutton\"><span>Grade 3<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','2')\" class=\"bf_button_large0 questionbutton\"><span>Grade 2<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_grade','1')\" class=\"bf_button_large0 questionbutton\"><span>Grade 1<\/span><\/a>\n     <br \/>\n     <br \/>\n    <\/div>\n",
                    "fields": "school_grade"
                };
                global.questions_cache["4"] = {
                    "id": "4",
                    "hide_answer_button": "1",
                    "question": "    <input type=\"hidden\" id=\"school_year\" name=\"school_year\" value=\"\" \/> <span class=\"question_text\"> What year of school are you in ?<\/span>\n    <div class=\"centerquestions\">\n     <a href=\"javascript:submitformQuestionForStudentValue('school_year','1')\" class=\"bf_button_large0 questionbutton\"><span>1st Year<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_year','2')\" class=\"bf_button_large0 questionbutton\"><span>2nd Year<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_year','3')\" class=\"bf_button_large0 questionbutton\"><span>3rd Year<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_year','4')\" class=\"bf_button_large0 questionbutton\"><span>4th Year<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_year','5')\" class=\"bf_button_large0 questionbutton\"><span>5th Year<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_year','Permanent Student')\" class=\"bf_button_large0 questionbutton\"><span>Permanent Student<\/span><\/a>\n     <br \/>\n     <br \/>\n    <\/div>\n",
                    "fields": "school_year"
                };
            }
            //stores all the question answers in fieldname : value pair
            t = window.localStorage.getItem("global.question_for_student");
            if (t != null && typeof t == "string") {
                global.question_for_student = JSON.parse(t);
                //if (typeof global.question_for_student.all_data === "undefined")
                //	global.question_for_student = {};
                //return true;
            } else {
                global.question_for_student = {};
                global.question_for_student.unanswered_questions = [];

            }
            var student_objects = ['all_data', 'answered_questions'];
            for (var i = 0; i < student_objects.length; i = i + 1) {
                var id = student_objects[i];
                if (typeof global.question_for_student[id] === "undefined")
                    global.question_for_student[id] = {}
                if (global.question_for_student[id] == null) {
                    global.question_for_student[id] = {}
                }
            }
            var student_array = ['next_questions'];
            for (var i = 0; i < student_array.length; i = i + 1) {
                var id = student_array[i];
                if (typeof global.question_for_student[id] === "undefined" || global.question_for_student[id] == null) {
                    global.question_for_student[id] = []
                }
            }

            var id = 'unanswered_questions';
            // default questions
            if (typeof global.question_for_student[id] === "undefined" || global.question_for_student[id] == null || typeof global.question_for_student.unanswered_questions !== "undefined" && global.question_for_student.unanswered_questions.length == 0) {
                global.question_for_student.unanswered_questions = [

                    /*{
							"id" : "2",
							"question" : "<span class=\"question_text\">Do you have a pet ?<\/span>\n<select class=\"question_select\" id=\"have_pet\">\n<option value=\"\">Select Yes or No<\/option>\n<option>Yes<\/option>\n<option>No<\/option><\/select>\n",
							"fields" : "have_pet"
						}*/
                    {
                        "id": "16",
                        "question": "<p class=\"question_text\"><b>What else do you want to learn ?<\/b><br\/>\nTell us what else you would like to learn, it can be any thing including stuff out side of school\n<\/p>\n<input class=\"question_input\" id=\"learn_other\" style=\"width: 90%\" placeholder=\"Math\"  type=\"text\" \/>\n",
                        "fields": "learn_other"
                    }, {
                        "id": "1",
                        "hide_answer_button": "1",
                        "question": "<input type=\"hidden\" id=\"school_level\"  name=\"school_level\" value=\"\" \/> <span class=\"question_text\"> What level of school are you in ?<\/span>\n    <div class=\"centerquestions\">\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','Primary')\" class=\"bf_button_large0 questionbutton\"><span>Primary<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','Middle School')\" class=\"bf_button_large0 questionbutton\"><span>Middle School<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','Junior High')\" class=\"bf_button_large0 questionbutton\"><span>Junior High<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','Highschool')\" class=\"bf_button_large0 questionbutton\"><span>Highschool<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','Homeschool')\" class=\"bf_button_large0 questionbutton\"><span>Homeschool<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','University')\" class=\"bf_button_large0 questionbutton\"><span>University<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','College')\" class=\"bf_button_large0 questionbutton\"><span>College<\/span><\/a>\n     <br \/>\n     <br \/>\n     <a href=\"javascript:submitformQuestionForStudentValue('school_level','Learning For Fun')\" class=\"bf_button_large0 questionbutton\"><span>Learning For Fun<\/span><\/a>\n     <br \/>\n     <br \/>\n    <\/div>\n",
                        "fields": "school_level",
                        "postcondition": 'var school_level = getStudentData("school_level") ; if (school_level  == "University" || school_level  == "College") { condition_questions.push("4");  } else if (school_level == "Learning For Fun") {} else {condition_questions.push("3");   } '
                    }
                ];
                initDefaultQuestions();
            }
            /*
					t = window.localStorage.getItem("global.question_for_student.all_data");
					if (t != null) {
						global.question_for_student.all_data = JSON.parse(t);
					} else
						global.question_for_student.all_data = {};

					// global.question_for_student.next_questions to be retrieved
					t = window.localStorage.getItem("global.question_for_student.next_questions");
					if (t != null) {
						global.question_for_student.next_questions = JSON.parse(t);
					} else
						global.question_for_student.next_questions = {};

					t = window.localStorage.getItem("answered_questions");
					if (t != null) {
						global.question_for_student.answered_questions = JSON.parse(t);
					} else
						global.question_for_student.answered_questions = {};
					t = window.localStorage.getItem("global.question_for_student.unanswered_questions");
					if (t != null) {
						global.question_for_student.unanswered_questions = t;
					} else {
						//global.question_for_student.unanswered_questions = [];
					}
					*/
            global.question_for_student.answered_questions_count = 0;
            global.question_for_student.skipped_questions_count = 0;
        } else {}
    } catch (e) {
        jslog("e", "initQuestionForSudent: " + e + " " + dumpvar(e));
    }
}

function initDefaultQuestions() {
    try {
        if (global.default_questions == null)
            global.default_questions = [];
        for (var i = 0; i < global.question_for_student.unanswered_questions.length; i = i + 1)
            global.default_questions.push(global.question_for_student.unanswered_questions[i].id);
    } catch (e) {
        jslog("e", "initDefaultQuestions: " + e + " " + dumpvar(e) + " \n" + dumpvar(global.default_questions) + " " + dumpvar(global.question_for_student.unanswered_questions));
    }
}
// callback if the photo fails to upload successfully.
function uploadfail(error) {
    //jslog("i", "uploadfail=" + dumpvar(error));
    if (typeof global.upload_fail === "undefined")
        global.upload_fail = 1;
    if (global.upload_fail > 3) {
        global.upload_fail = 0;
        if (error.code === FileTransferError.CONNECTION_ERR || error.code === FileTransferError.ABORT_ERR) {
            networkError();
            //jslog("i", "FileTransfer: uploadfail");
        } else if (FileTransferError.FILE_NOT_FOUND_ERR == error.code) {
            navigator.notification.alert("The file appears to of been removed: " + global.upload_queue[0]['questionfileURI'], null, "File not accessible", "OK");
            completedUploadQueue();
        } else {
            //invalid uri or another error
            navigator.notification.alert("An error has occurred: Code = " + error.code + " file = " + global.upload_queue[0]['questionfileURI'], null, "File not accessible", "OK");
            jslog("e", "global.upload_queue " + dumpvar(global.upload_queue[0]));
            completedUploadQueue();
        }
    } else {
        global.upload_fail++;
        // jump right back into retrying upload
        global.processing_queue = false;
        global.processing_queue_start_time = new Date().getTime();
        processUploadQueue();
    }
}

function networkErrorRetry(button) {
    if (typeof button !== "undefined")
        if (button == 1) {
            //jslog("i", "networkErrorRetry: alert Retry done");
            processUploadQueue();
        } else {

        }
}

function networkError() {
    //jslog("i", "networkError: started" + global.networkerror);
    global.networkerror = localNumber("global.networkerror");
    //jslog("i", "networkError: global.networkerror 1=" + global.networkerror);
    global.networkerror++;
    //jslog("i", "networkError: global.networkerror 2=" + global.networkerror);
    if (global.networkerror > 3) {
        global.isloading = false;
        global.processing_queue = false;
        global.networkerror = 0;
        navigator.notification.confirm("Connection failed, Check your internet connection. To submit questions internet access is required",
            networkErrorRetry, "Check Internet Connection", ["Retry", "Cancel"]);
        closethankyou();
    } else {
        global.isloading = false;
        global.processing_queue = false;
        //jslog("i", "networkError: global.networkerror 3=" + global.networkerror);
        // 	setTimeout(processUploadQueue, 2000);
    }
    localNumberSave("global.networkerror", global.networkerror);
}

function uploadsuccess(response) {
    try {
        global.isloading = false;
        global.upload_fail = 0;
        //jslog("i", "uploadsuccess: started");
        var data = JSON.parse(response.response);
        if (!setQuestionData(data)) {
            //jslog("i", "setQuestionData: failed");
            completedUploadQueue();
            return false;
        }
    } catch (e) {
        //jslog("i", "uploadsuccess error:" + e.message + "response= " + response.response);
        //jslog("i", "response = " + response.response);
    }
    try {
        global.upload_count = 0;
        uploadQuestionSuccess(data);
        resetThankYou();
        completedUploadQueue();
    } catch (e) {
        //jslog("i", "uploadsuccess: " + e + " " + dumpvar(e));
    }
}

// questions

function query(sql_query, data, success, failure) {
    var self = this;
    try {
        if (typeof success === "undefined")
            this.success = successCB;
        else
            this.success = success;
        if (typeof failure === "undefined")
            this.failure = function(e, e1) {
                jslog("e", "new query( " + sql_query + " e=" + e + " e dump = " + dumpvar(e1) + " e1= " + e1 + " e1 dump " + dumpvar(e1));
            };
        else
            this.failure = failure;
        this.sql_query = sql_query;
        //jslog("i", "query: starting transaction " + sql_query)
        db.transaction(function(tx) {
            new queryDB(tx, self.sql_query, data, self.success, self.failure);
        }, function(e) {
            errorCB(e, "query transaction " + self.sql_query);
        }, successCB);
    } catch (e) {
        jslog("e", "query error: " + self.sql_query + "e= " + e + " " + dumpvar(e));
    }
}

function queryDB(tx, sql_query, data, success, error) {
    var self = this;
    if (typeof tx === "undefined") {
        if (typeof error == "function") {
            return error("transcation not defined");
        } else {
            return erroCB("queryDB transcation not defined " + sql_query);
        }
    }
    if (typeof data == "function") {
        jslog("e", "queryDB data is a function, check parameters " + sql_query);
        throw "queryDB data is a function, check parameters " + sql_query;
        return false;
    }
    if (typeof data !== "undefined")
        this.data = data;
    else
        this.data = null;
    this.query = sql_query;
    //jslog("i", "queryDB: sql_query= " + sql_query + " data= "
    //			+ JSON.stringify(data));
    if (typeof error === "undefined") {
        this.errorCB = function(err, err1) {
            //if (err) {
            //jslog("i", err);
            //		if (typeof err.code !== "undefined")
            //jslog("i", "queryDB errorCB: Error processing SQL: " + err.code);
            if (typeof err.message !== "undefined") {
                //jslog("i", "queryDB errorCB: Error processing SQL: "
                //						+ err.message);
                //jslog("i", "queryDB errorCB: sql_query " + self.query + " data = "
                //					+ dumpvar(self.data) + " error dump " + dumpvar(err)
                //					+ " error dump 1" + dumpvar(err1));
                //} else {
                //jslog("i", "SQL Error, no info");
                //}
            }
        };
    } else {
        this.errorCB = error;
    }

    if (typeof success === "undefined") {
        this.successCB = function(tx, results) {
            //jslog("i", "queryDB: query success " + self.query);
        }
    } else {
        this.successCB = success;
    }
    //jslog("i", "queryDB successcb = " + this.successCB);
    //jslog("i", "queryDB errorcb = " + this.errorCB);
    try {
        tx.executeSql(self.query, self.data, self.successCB, self.errorCB);
        //jslog("i", "queryDB: finished " + sql_query);
    } catch (e) {
        jslog("e", "queryDB executeSql: " + e + " " + dumpvar(e));
    }

}

//global.quesions

function sql2assoc(tx) {
    // tx.executeSql('DROP TABLE QUESTIONS'); // used to reset db
    global.purchases_uuid = localStorage2Array("purchases_uuid");
    //purchases_id = localStorage2Array("purchases_id");
    new queryDB(tx, 'SELECT * FROM QUESTIONSV2 ORDER BY questionid desc limit 15', [],

        function(tx, results) {
            global.questions = [];
            var len = results.rows.length;
            while (len--) {
                global.questions.push(results.rows.item(len));
            }
            localObjectSave("global.questions", global.questions);
        });

}

function hasAnswerAccess(question_uuid) {
    if (contains(global.answeraccess, question_uuid) || contains(global.purchases_uuid, question_uuid)) {
        return true;
        // give access
    } else {
        if (answerSlotsAvailable()) {
            global.answeraccess.push(question_uuid);
            localObjectSave("global.answeraccess", global.answeraccess);
            return true;
        }
    }
    return false;
}

function showQuestionsAssoc() {
    try {
        if (typeof global.questions === "undefined" || global.questions == null) {
            return false;
            jslog("e", "global.questions is null");
            return true;
        }
        var len = global.questions.length;
        var lquestionid = 0;
        if (len > 0) {
            jslog("i", "showQuestionsAssoc: len " + len);
            purchases_id = localStorage2Array("purchases_id");
            q = "";
            html = "";
            html1 = "";
            showDiv("update1");
            showDiv("update2");
            showDiv("update3");
            // prevents huge question lists

            global.stats = null;

            try {
                global.stats = localObject("global.stats");
            } catch (e) {
                jslog("e", "global.stats json pharse error" + window.localStorage.getItem("global.stats"))
                global.stats = {};
            }

            c = 0;
            //for ( var i = len - 1; i >= 0 && (c < 10); i--) {
            // && i < 10
            var html = "";
            var qi = len;
            while (qi--) {
                c++;
                if (0) {
                    jslog("i", "showQuestions: " + qi + " qid " + global.questions[qi].questionid + "question_uuid " + global.questions[qi].question_uuid + "total ans:" + global.questions[qi].total_answers + " des:" + global.questions[qi].description + " file:" + global.questions[qi].questionfileURI + " isImage: " + isImage(global.questions[qi].questionfile));
                }
                qdescription = global.questions[qi].description;
                if (qdescription != null && qdescription != "") {
                    qdescription = qdescription.substring(0, 160);
                }
                if ((global.questions[qi].questionfileURI || qdescription) && global.questions[qi].questionid != null) {
                    lquestionid = global.questions[qi].questionid;
                    questionfile = null;
                    if (objectHasValue(global.questions[qi], 'questionfileURI'))
                        questionfile = global.questions[qi].questionfileURI;
                    q = formatAnswer("questionpage", global.questions[qi].question_uuid, global.questions[qi].questionid, qdescription, global.questions[qi].full_answer, //answer here
                        questionfile, global.questions[qi].total_answers, global.questions[qi].total_flags);
                    html += q;
                }
            }
            setDivHTML("questionslist", html);
            setDivHTML("questionslist1", html);
            if (html != null && html != "") {
                hideDiv("examples");
                showDiv("myquestions");
                hideDiv("examples1");

                //				for (i = 0; i < 3; i++) {
                //				hideDiv("examples" + i);
                //hideDiv("myquestions" + i);
                //				}
                if (!global.hasmoved) {
                    col1id = document.getElementById("connecttab");
                    questions = document.getElementById("examples1");
                    col1id.appendChild(questions);
                    global.hasmoved = true;
                }
            }

            showUpdateButtons();
        }
    } catch (e) {
        jslog("e", "showQuestions error" + dumpvar(e));
    }
}



function setQStats(qid, total) {
    global.stats[qid] = {};
    global.stats[qid]['total_answers'] = total;
}

function getQuestionAnswers(qid) {
    var total_answers = 0;
    if (global.stats != null && typeof global.stats[qquestionid] !== "undefined" && typeof global.stats[qquestionid]['total_answers'] !== "undefined") {

        total_answers = global.stats[qquestionid]['total_answers'];
    }
    return total_answers;
}

function addRandomUriString(file) {
    try {
        if (typeof file !== "undefined" && file != null) {
            if (file.indexOf("?") === -1) {
                return file + "?r=" + Math.random();
            }
            return file + "&r=" + Math.random();
        }
    } catch (e) {
        jslog("e", "addRandomUriString error" + dumpvar(e));
    }
    return "";
}

// there are more then one list of questions that can exist at once
// so the counter is used to make the id's unique
//<div style="display:none" id="question_answer_##questionid##_##unique_formatanswer_count##"></div>
// mode = "notification" - don't show answer, show view button
// mode = "questionpage" - show full answer
function formatAnswer(mode, qquestion_uuid, qquestionid, qdescription, qanswer, qquestionfile, total_answers, total_flags) {
    var hasaccess = false;
    if (typeof global.formatanswer === "undefined")
        global.formatanswer = 0;
    else
        global.formatanswer++;
    if (!(mode == "notification" || mode == "questionpage")) {
        jslog("e", "formatAnswer mode error " + mode);
        return false;
    }
    //, full_answer
    global.unique_formatanswer_count = global.unique_formatanswer_count + 1;
    /*
	jslog("i", "formatAnswer (mode = " + mode + "qquestionid= " + qquestionid
			+ " qdescription=" + qdescription + " qanswer= " + qanswer
			+ " qquestionfile= " + " total_answers= " + total_answers);
			*/
    //+"full_answer="+full_answer
    try {
        if (global.question_template == null) {
            global.question_template = document.getElementById("question_template").innerHTML;
        }
    } catch (e) {
        jslog("e", "formatAnswer" + dumpvar(e));
    }
    try {
        //jsurl = "loadURL('" + global.siteUrl + "/student_request/" + qquestionid
        //		+ "?sid=" + getSid() + "')";
        hasaccess = 'no';
        if (typeof qanswer !== "undefined" && total_answers > 0) {
            jsurl = "void(0)";
            if (hasAnswerAccess(qquestion_uuid)) {
                hasaccess = "yes";
            } else {
                jsurl = "loadQuestion('" + qquestion_uuid + "',showInstantAccess)";
            }
        }
        //"showDiv('question_answer_" + qquestion_uuid + "_" + global.unique_formatanswer_count + "')";
        else
            jsurl = "void(0)"
        questionimage = "";
    } catch (e) {
        jslog("e", "formatAnswer 1" + dumpvar(e));
    }
    try {
        if (qquestionfile != null && isImage(qquestionfile)) {
            //addRandomUriString , might not be needed now
            if (mode == "questionpage")
                questionimage = "<img class=\"question_item_image\" src=\"" + (qquestionfile) + "\" />";
            else
                questionimage = "<img class=\"question_notify_item_image\" src=\""

            + (qquestionfile) + "\" />";
        }
    } catch (e) {
        jslog("e", "formatAnswer 2" + dumpvar(e) + "questionimage:" + questionimage + "qquestionfile:" + qquestionfile + "template:" + template);
    }
    //q += "<p onclick=\"" + jsurl + "\">";

    try {
        if (typeof qquestionfile !== "undefined" && qquestionfile != null) {
            if (qdescription != null && qdescription != "") {} else {
                // could be a doc file, put in some text to help user out other
                // wise we get a blank template with no image to show
                if (isImage(qquestionfile)) {
                    qdescription = "Uploaded " + getFileExtension(qquestionfile) + " image";
                } else {
                    qdescription = "Uploaded " + getFileExtension(qquestionfile) + " file";
                }
            }
        } else if (qdescription != null && qdescription != "") {

        } else {
            // this should not happen
        }
        if (qanswer != null && qanswer != "" && qanswer != "null") {
            if (mode == "notification") {
                qanswer = "";
            } else {
                //qanswer = "<br/><b>Answer</b>: " + qanswer;
            }
        } else {
            qanswer = "";
        }
        //	var total_answers = 0;
        /*
         * jslog("i","global.stats typeof " + typeof global.stats[qquestionid]);
         * jslog("i","global.stats typeof " + typeof
         * global.stats[qquestionid]['total_answers']);
         */
        //off
        var msg = null;
        var hasanswer = "no";
        if (total_answers != null && total_answers > 0) {
            hasanswer = "has";
            if (total_answers > 1) {
                msg = "You have " + total_answers + " answers";
            } else if (total_answers > 0) {
                msg = "You have an answer";
            }
        } else {
            msg = "No answers yet, try again later!";
        }
        var ispro = "freeanswer";
        var showbuy = "freeanswer";
        if (contains(global.purchases_uuid, qquestion_uuid + "")) {
            ispro = "proanswer";
            showbuy = "proanswer";
        } else {
            if (!(total_answers > 0)) {
                showbuy = "freeanswer";
                jsurl = "loadQuestion('" + qquestion_uuid + "',showAskforhelp)";
                //jsurl = 'lessonCreatePitch()';
            } else {
                showbuy = "proanswer"; //allready answered
            }
        }
        //	if (0)
        //jslog("i", "formatAnswer: ispro= " + ispro + " qquestion_uuid = " + typeof qquestion_uuid + " purchases_uuid = "
        //					+ JSON.stringify(purchases_uuid));
    } catch (e) {
        jslog("e", "formatAnswer 2" + dumpvar(e));
    }
    try {
        if (total_flags > 0) {
            // then question has been flagged with no answers
            jsurl = "void(0)";
            hasanswer = "has";
            hasaccess = "yes";
            // free up question slot
            if (contains(global.answeraccess, qquestion_uuid)) {
                idx = global.answeraccess.indexOf(qquestion_uuid);
                var removed_id = global.answeraccess.splice(idx, 1);
            }
            msg = "Your question may have some problems";
        }
    } catch (e) {
        jslog("e", "formatAnswer total_flags" + dumpvar(e));
    }
    try {
        //jslog("i", "formatAnswer: qid :" + qquestionid + " quid :" + qquestion_uuid + ": total_answers=" + total_answers);
        q = global.question_template;
        if (hasanswer == 'has' && hasaccess == 'no') {
            q = replaceAll("##ask_get_instant##", 'yes', q);
            q = replaceAll("##viewanswer##", 'no', q);
        } else {
            q = replaceAll("##ask_get_instant##", 'no', q);
            if (mode == 'notification')
                q = replaceAll("##viewanswer##", 'yes', q);
            else q = replaceAll("##viewanswer##", 'no', q);
        }
        q = replaceAll("##count##", global.formatanswer, q);
        q = replaceAll("##questionid##", qquestionid, q);
        q = replaceAll("##question_uuid##", qquestion_uuid, q);
        q = replaceAll("##sid##", global.sid, q);
        q = replaceAll("##description##", qdescription, q);
        q = replaceAll("##hasanswer##", hasanswer, q);
        q = replaceAll("##answer##", qanswer, q);
        q = replaceAll("##questionfile##", qquestionfile, q);
        q = replaceAll("##questionimage##", questionimage, q);
        q = replaceAll("##ispro##", ispro, q);
        q = replaceAll("##showbuy##", showbuy, q);
        q = replaceAll("##msg##", msg, q);
        q = replaceAll("##jsurl##", jsurl, q);
        q = replaceAll("##hasansweraccess##", hasaccess, q);
        q = replaceAll("##mode##", mode, q);
        q = replaceAll("##unique_formatanswer_count##", global.unique_formatanswer_count, q);
        //jslog("i", q);
    } catch (e) {
        jslog("e", "formatAnswer 3" + dumpvar(e));
    }

    return q;
}

function http_get_questions(ids) {
    var request = new XMLHttpRequest();
    var message = localObject("messages_to_student")
    var messageids = "";
    sep = "";
    for (var n in message) {
        //if (typeof  message[n]['id'] != "undefined")
        if (!contains(global.confirmedreceived, n)) {
            messageids += sep + n;
            sep = ",";
        }
    }
    url = global.siteUrl + "/app_" + global.app_version + "_questions_update";
    request.open("POST", url);
    request.setRequestHeader("Content-type",
        "application/x-www-form-urlencoded");
    data = "ids=" + encodeURIComponent(ids) + "&sid=" + encodeURIComponent(global.sid) + "&uuid=" + encodeURIComponent(window.localStorage.getItem("uuid")) + "&regid=" + encodeURIComponent(window.localStorage.getItem("regid"));
    data += "&type=" + encodeURIComponent(device.platform);
    data += "&recievedmessages=" + encodeURIComponent(messageids);
    data += "&purchases_uuid=" + encodeURIComponent(window.localStorage.getItem("purchases_uuid"));
    //	data += "&purchases=" + encodeURIComponent(window.localStorage.getItem("purchases"));
    //if (0)
    jslog("i", "http_get_questions:" + ids + " url " + url + " data = " + data);

    if (getDevice() != "ripple")
        request.setRequestHeader("Connection", "close");
    request.onreadystatechange = function() { // Call a function when the
        if (request.readyState == 4) {
            if (request.status == 200 || request.status == 0) {
                //jslog("i", "http_get_questions response :"
                //		+ request.responseText);
                if (request.responseText == "" || request.responseText == null) {
                    networkError();
                    //jslog("i", "http_get_questions: networkError");
                    // if server error run update any how to show questions
                    if (global.force_update) {
                        //jslog("i", "http_get_questions: global.force_update")
                        updateQuestionsList();
                        global.force_update = false;
                    }
                    updateQuestionCompleted();

                } else {
                    // check to see if any changes in data sense last global.stats
                    if (updateQuestionsData(request.responseText)) {
                        // updateQuestionsList was called
                    } else {
                        // updateQuestionsList was not called
                        if (global.force_update) {
                            //jslog("i", "http_get_questions: global.force_update")
                            updateQuestionsList();
                            global.force_update = false;
                        }
                    }
                    updateQuestionCompleted();
                }
            }
        }
    }

    request.send(data);

}

function updateQuestionsData(req) {
    var temp = null;
    var update_count = 0;
    try {

        //jslog("i", "updateQuestionsData: setting global.data_update: " + req)
        temp = JSON.parse(req);

        // update global.confirmedreceived
        if (typeof temp['recieved'] != "undefined" && temp['recieved'] != "") {
            r = temp['recieved'].split(",");
            for (var i = 0; i < r.length; i++) {
                id = r[i];
                if (!contains(global.confirmedreceived, id)) {
                    global.confirmedreceived.push(id);
                }
            }
            localObjectSave("global.confirmedreceived", global.confirmedreceived);
        }

        // process questions
        global.data_update = temp['questions'];
        if (typeof global.data_update['sid'] !== "undefined")
            setSid(temp['sid']);
        // questions for users to answer
        try {
            if (typeof temp['questions_for_student'] !== "undefined")
                addQuestionsToUnanswered(temp);
        } catch (e) {
            jslog("e", "setQuestionData " + e + " " + JSON.stringify(e));
        }
        try {
            //videos
            if (typeof temp['videos'] != "undefined") {
                global.contribution = {};
                global.contribution.videos = temp['videos'];
                global.contribution.lessons = temp['lessons'];
                localObjectSave("global.contribution", global.contribution);
            }
        } catch (e) {
            jslog("e", "setQuestionData videos count" + e + " " + JSON.stringify(e));
        }

        try {
            // currently to avoid the issue of having more then one message at a time
            // for a user we don't send questions updates tell message is received
            // a template can include a call to sendUpdatedQuestionMessage() to
            // send any messages related to question updates if user skips / closes
            // message box
            if (typeof temp['message_for_student'] !== "undefined") {
                sendMessageToStudent(temp);
                return false;
            }
        } catch (e) {
            jslog("e", "setQuestionData " + e + " " + JSON.stringify(e));
        }

    } catch (e) {
        jslog("e", "setQuestionData " + e + " " + JSON.stringify(e));
        global.data_update = null;
        return false;
    }
    /*
	try {
		// window.localStorage.setItem("global.stats", JSON.stringify(data));

		for ( var key in global.data_update) {
			update_count++;
			//jslog("i", "key = " + key + " data = " + dumpvar(global.data_update[key]));
			var obj = global.data_update[key];
			//jslog("i", "updateQuestionsData: key = " + key //+ " id =" + obj['id']
			//		+ " total_answers = " + obj['total_answers'] + " since_time_answers = " + obj['since_time_answers']);

		}
	} catch (e) {
		jslog("e", "updateQuestionsData: data parse error " + e + " data = " + req);
	}
	*/
    sendUpdatedQuestionMessage();
    //
    // return;
    //	questions = window.localStorage.getItem("question_id");
    //	question_list = new Array();
    //	if (questions != null) {
    //		question_list = JSON.parse(questions);
    //	}
    /*
		global.stats = new Array();
		try {
			global.stats = JSON.parse(window.localStorage.getItem("global.stats"));
		} catch (e) {
		//jslog("i", "global.stats json pharse error"
					+ window.localStorage.getItem("global.stats"))
		}
	*/
    //jslog("i","updateQuestionsData" + data.len);
    return update_count;
    //jslog("i","updateQuestionData: list repopulated")
}

// notify user of new answers by searching threw answer current counts and past answer counts 
function sendUpdatedQuestionMessage() {
    if (global.data_update == null)
        return false;
    try {
        //jslog("i", "updateQuestionsData calling findUpdated");
        findUpdated();
    } catch (e) {
        jslog("e", "updateQuestionsData: sql error " + dumpvar(e));
    }
}

function sendMessageToStudent(data) {
    // set track to false if you want to always display message
    // timeout is set if you want the message to disapear after timeout ms
    // location can be hover for top, hover_bottom , hover_center
    var track = true;
    var timeout = 0;
    var message = {};
    var location = "hover";
    try {
        if (typeof data['message_for_student'] === "undefined") {
            return false;
        }
        if (typeof data['message_for_student']['track'] !== "undefined")
            track = data['message_for_student']['track'];
        if (typeof data['message_for_student']['timeout'] !== "undefined")
            timeout = data['message_for_student']['timeout'];
        if (typeof data['message_for_student']['location'] !== "undefined")
            location = data['message_for_student']['location'];
        if (track)
            message = localObject("messages_to_student");
        //jslog("i","sendMessageToStudent: " + dumpvar(message));
        if (objectHasValue(data['message_for_student'], 'html') && objectHasValue(data['message_for_student'], 'id')) {
            //jslog("i","sendMessageToStudent: incoming message " + dumpvar(data['message_for_student']));
            if (objectHasValue(data['message_for_student'], 'id')) {
                var id = data['message_for_student']['id'];
                //jslog("i","sendMessageToStudent: has id " + id);
                if (track && objectHasValue(message, id)) {
                    // message all ready sent to user so continue to questionmessage
                    //jslog("i", "sendMessageToStudent: message all ready sent " + message[id]);
                    message = null;
                    return sendUpdatedQuestionMessage();
                } else {
                    //jslog("i","sendMessageToStudent: sending ");
                    setDivHTML('generic_message_content', data['message_for_student']['html']);
                    if (location != '')
                        setClass('generic_message', location);
                    showDiv('generic_message');
                    global.student_message = true;
                    if (timeout > 0)
                        setTimeout(closeStudentMessage, timeout);

                    //todo create a cleanup for messages if the amount of messages get large
                    message[id] = new Date().getTime();
                    if (track)
                        localObjectSave("messages_to_student", message);
                    message = null;
                    return true;
                }
            }
        }
    } catch (e) {
        jslog("e", "sendMessageToStudent: sql error " + dumpvar(e));
    }
    return sendUpdatedQuestionMessage();
}

function closeStudentMessage() {
    global.student_message = false;
    hideDiv('generic_message');
    sendUpdatedQuestionMessage();
}

function getQuestion(question_uuid) {
    try {
        var len = global.questions.length;
        updated = false;
        while (len--) {
            if (global.questions[len].question_uuid == question_uuid) {
                return global.questions[len];
            }
        }
    } catch (e) {
        jslog("e", "getQuestion: " + e + "dump:" + dumpvar(e) + "obj = " + dumpvar(question_uuid));
    }

    return null;
}

function updateGlobalQuestion(data) {
    try {
        var len = global.questions.length;
        updated = false;
        while (len--) {
            if (global.questions[len].question_uuid == data.question_uuid) {
                for (var n in data) {
                    global.questions[len][n] = data[n];
                }
                return global.questions[len];
            }
        }
        global.questions.push({
            questionid: data.questionid,
            question_uuid: data.question_uuid,
            questionfileURI: data.questionfileURI,
            description: data.description,
            created: data.created,
            createdint: data.createdint
        });
        localObjectSave("global.questions", global.questions);
    } catch (e) {
        jslog("e", "updateQuestion: " + e + "dump:" + dumpvar(e) + "obj = " + dumpvar(question_uuid));
    }
    return null;
}

// desc_file = true when updating description + file other wise
// false
function updateQuestion(obj, updatemyquestions, desc_file) {
    if (typeof desc_file === "undefined")
        desc_file = false;
    /*jslog("i", "updateQuestion: updatemyq=" + updatemyquestions + " id ="
				+ obj['id'] + " total_answers = " + obj['total_answers']
				+ " since_time_answers = " + obj['since_time_answers']);
	 */
    try {
        var scb = null;
        var id = obj['id'] * 1;
        //if (desc_file) {
        //	var qdescription = obj['description'];
        //	var qquestionfile = obj['questionfileURI'];
        //} else {
        var since_time_answers = obj['since_time_answers'] * 1;
        var total_answers = obj['total_answers'] * 1;
        var total_flags = obj['total_flags'] * 1;
        var full_answer = obj['full_answer'];
        //}
        var scb = null;
        len = global.questions.length;
        updated = false;
        while (len--) {
            if (global.questions[len].questionid == id) {
                updated = true;
                global.questions[len].total_answers = total_answers;
                global.questions[len].total_flags = total_flags;
                global.questions[len].since_time_answers = total_answers;
                global.questions[len].full_answer = full_answer;
            }
        }
        if (updated) {
            localObjectSave("global.questions", global.questions);
            if (updatemyquestions)
                updateQuestionsList();
        }
    } catch (e) {
        jslog("e", "updateQuestion: " + e + "dump:" + dumpvar(e) + "obj = " + dumpvar(obj));
    }
}

// hides please wait message
function updateQuestionCompleted() {
    global.isUpdating = false;
    update = document.getElementById("update_questions");
    update.style.display = "none";
    update = document.getElementById("update_questions1");
    update.style.display = "none";
}

function updateNotificationList(question_list) {

    // needs testing
    //	 window.localStorage
    //		.setItem("unseen_question_list",JSON.stringify(question_list));
    //todo update questions db with answers and
    //retrieve file name so notifications can see image
    if (question_list == null) {
        jslog("d", "updateNotificationList: question_list null");
        return false;
    }
    setDivHTML('questionupdatelink', "");
    question_listn = {};
    i = 0;
    var q = "";
    //jslog("i", "updateNotificationList: processing" + JSON.stringify(question_list));
    for (var key in question_list) {
        var obj = question_list[key];
        if (typeof obj !== "undefined" && obj != null && typeof obj['questionid'] !== "undefined") {
            //jslog("i", "updateNotificationList: key:" + key + ":=" + obj[1]);
            question_listn[key] = obj;
            //qquestionfile,total_answers) {

            q += formatAnswer("notification", obj['question_uuid'], obj['questionid'], obj['description'], obj['answer'], "", obj['total_answers'], obj['total_flags']);
            i++;
        }
    }
    if (q != "") {
        setDivHTML('questionupdatelink', q);
        question_list = question_listn;
        //jslog("i","qid = " + questionupdatelink.innerHTML);
        //jslog("i", "updateNotificationList:" + question_list.length);
        //jslog("i","updateNotificationList: done " + JSON.stringify(question_list));
        //jslog("i", "updateNotificationList:" + question_list);

        showDiv("questionupdate");
        scrollToTop();
    }
}

function skipQuestionForSudent() {
    initQuestionForSudent();
    //jslog("i", "skipQuestionForSudent: global.question_for_student.unanswered_questions.length "			+ global.question_for_student.unanswered_questions.length);
    if (global.question_for_student == null) {
        jslog("e", "skipQuestionForSudent global.question_for_student null");
        return showQuestionsForUser(2);
    }
    if (typeof global.question_for_student.skipped_questions_count === "undefined") {
        global.question_for_student.skipped_questions_count = 0;
    }

    // move last question to first of array
    var temp = global.question_for_student.unanswered_questions.pop();
    // if we reach skipped question means we cycled threw entire list at least once
    setSkipped(temp.id);
    global.question_for_student.unanswered_questions.unshift(temp);
    last = global.question_for_student.unanswered_questions.length - 1;
    global.question_for_student.skipped_questions_count++;

    // only one answer so not possible to show another question
    if (global.question_for_student.unanswered_questions.length == 1) {
        //askBuyProAnswer();
        askCreateLesson();
        return true;
    }
    /*, "skipQuestionForSudent count = " + global.question_for_student.skipped_questions_count + "answered count = "
			+ global.question_for_student.answered_questions_count + " alert logic = "
			+ (global.question_for_student.answered_questions_count < 1 && global.question_for_student.skipped_questions_count > 1) + " logic = "
			+ (global.question_for_student.skipped_questions_count > (2 - global.question_for_student.answered_questions_count))*/
    //" unans = "
    //+ JSON.stringify(global.question_for_student.unanswered_questions)
    //	);
    // if they skip three questions or answer two then show them the pay page
    // if they are skipping three questions they just might not want to answer questions
    try {
        var proanswer = 0;
        if (isSkipped(global.question_for_student.unanswered_questions[last]['id'])) {
            proanswer = 1;
            /*
			jslog("i", "skipQuestionForSudent "
					+ global.question_for_student.unanswered_questions[last].id
					+ " all ready skipped ");
					*/
        }
        if (global.question_for_student.skipped_questions_count > (1 - global.question_for_student.answered_questions_count) || global.question_for_student.answered_questions_count > 1) {
            proanswer = 1;
        }
        if (proanswer > 0) {
            askCreateLesson();
            //			askBuyProAnswer();
            return true;
        }
    } catch (e) {
        jslog("e", "skipQuestionForSudent error 1" + e);
    }
    if (global.question_for_student.unanswered_questions.length == 1) {
        return askCreateLesson();
        //		return askCreateLesson(); //return askBuyProAnswer();
    }
    if (global.question_for_student.answered_questions_count < 1 && global.question_for_student.skipped_questions_count > 1) {
        centerMessage("Please complete at least one question", 0);
    }
    showQuestionsForUser();

}


function inUnanswered(qid) {
    try {
        len = global.question_for_student.unanswered_questions.length;
        while (len--) {
            if (global.question_for_student.unanswered_questions[len].id == qid)
                return true;
        }
    } catch (e) {

    }
    return false;

}

function isAnswered(qid) {
    if (global.question_for_student == null)
        initQuestionForSudent();
    if (typeof global.question_for_student.answered_questions !== "undefined" && typeof global.question_for_student.answered_questions[qid] === "undefined") {
        // question is unanswered
        return false;
    }
    return true;
}
// return -1 when no next question

function isSkipped(id) {
    try {
        if (typeof global.skipped_questions[id] === "undefined")
            return false;
        if (global.skipped_questions[id] == null)
            return false;
        if (global.skipped_questions[id] == 1)
            return true;
        return false;
    } catch (e) {
        jslog("e", "isSkipped error: " + id + "dump:" + dumpvar(e));
    }
    return false;
}

function setSkipped(id) {
    global.skipped_questions[id] = 1;
    saveStudentData('skipped', id, id);
}

// returns the next question to be answered
// also sorts the unanswered questions by pushing skipped to front 
// and removes all ready answered questions
function nextQuestion() {
    var skipped_unanswered_questions = [];
    var unanswered = [];
    var temp_unanswered_questions = null;
    try {
        // first remove all answered questions from the unanswered_questions list
        // second push all skipped questions to the begining of array and add unanswered unskipped 
        // to end
        // find last unanswered and return
        //jslog("i",
        //			"nextQuestion: global.question_for_student.unanswered_questions.length "
        //					+ global.question_for_student.unanswered_questions.length);
        try {
            // remove all answered questions
            temp_unanswered_questions = global.question_for_student.unanswered_questions;
            global.question_for_student.unanswered_questions = [];

            for (var question = 0; question < temp_unanswered_questions.length; question = question + 1) {
                var qid = temp_unanswered_questions[question].id;

                if (!isAnswered(qid)) {
                    //jslog("i","qid not answered= " + qid + " " + question);
                    if (!inUnanswered(qid)) global.question_for_student.unanswered_questions.push(temp_unanswered_questions[question]);
                } else {
                    //jslog("i","qid answered= " + qid);
                }
            }
        } catch (e) {
            jslog("e", "nextQuestion error: remove answered" + dumpvar(e));
        }
        //global.question_for_student.unanswered_questions = temp_unanswered_questions;
        //return global.question_for_student.unanswered_questions;
        try {

            // push all skipped questions to front of array
            //temp_unanswered_questions = global.question_for_student.unanswered_questions;
            //global.question_for_student.unanswered_questions = [];
            skipped_unanswered_questions = [];
            unanswered = [];
            for (var question = 0; question < global.question_for_student.unanswered_questions.length; question = question + 1) {
                //jslog("i", "question=" + question);
                var qid = global.question_for_student.unanswered_questions[question].id;
                if (isSkipped(qid)) {
                    skipped_unanswered_questions.push(global.question_for_student.unanswered_questions[question]);
                } else {
                    unanswered.push(global.question_for_student.unanswered_questions[question]);
                }
            }
            global.question_for_student.unanswered_questions = skipped_unanswered_questions.concat(unanswered);
        } catch (e) {
            jslog("e", "nextQuestion error: skipped " + e + "dump" + dumpvar(e));
            return false;
        }
        //return unanswered_questions;
        try {
            question = global.question_for_student.unanswered_questions.length - 1;
            if (question >= 0 && typeof global.question_for_student.unanswered_questions[question] !== "undefined" && typeof global.question_for_student.unanswered_questions[question].id !== "undefined") {
                var qid = global.question_for_student.unanswered_questions[question].id;

                //jslog("i", "nextQuestion: skipped :" + isSkipped(qid) + ": isAnswered " + isAnswered(qid));

                if (!isSkipped(qid) && !isAnswered(qid)) {
                    return global.question_for_student.unanswered_questions[question];
                }
                // must be no next questions
                return null;
            } else {
                //jslog("i", "nextQuestion return: id not found" + question + " len " + global.question_for_student.unanswered_questions.length);
                return null;
            }

        } catch (e) {
            jslog("e", "nextQuestion return" + dumpvar(e));
        }
        jslog("e", "nextQuestion return, should not reach here");
        return null;
    } catch (e) {
        jslog("e", "nextQuestion: error " + e);
    }
    return null;
}

function showQuestionsForUser(thanks) {
    /* question spec
     * int qid
     * text question html
     * array data fields
     */
    //jslog("i", "showQuestionsForUser");
    try {
        initQuestionForSudent();
        try {

            process_addquestions_queue();
        } catch (e) {
            //showQuestionsForUser
            jslog("e", "showQuestionsForUser error" + e + dumpvar(e));
        }
        if (typeof thanks !== "undefined" && thanks > 0) {
            switch (thanks) {
                case 1:
                    // show thanks
                    //jslog("i", "showQuestionsForUser thanks");

                    break;
                case 2:
                    // show skipped
                    //jslog("i", "showQuestionsForUser skipped");

                    break;
                case 3:
                    // first question after submit
                    // ask for description if missing
                    // 
                    return showDescriptionQuestion();
                    break;
            }
            // set message
            // set timeout to hide
        }
        var question = -99;
        var qid = 0;
        try {
            if (global.question_for_student.unanswered_questions.length == 0) {
                //jslog("i", "showQuestionsForUser: no unanswered questions");
                return askCreateLesson();
                //			return askBuyProAnswer();
            }
        } catch (e) {
            jslog("e", "showQuestionsForUser 1 length1:" + e + dumpvar(e));
        }

        question = nextQuestion();
        //jslog("i", "showQuestionsForUser nextQuestion = " + question);
        if (question == null) {
            //jslog("i", "showQuestionsForUser: proanswer 1a question = null ");
            return askCreateLesson();
            //			return askBuyProAnswer();
        }
        if (typeof question == "object" && typeof question['id'] !== "undefined") {
            //jslog("i", "showQuestionsForUser nextQuestion = " + question['id']);
        } else {
            //jslog("i", "showQuestionsForUser nextQuestion = " + question);
        }
        if (typeof question === "undefined") {
            //jslog("i", "showQuestionsForUser: proanswer 1");
            return askCreateLesson();
            //			return askBuyProAnswer();
        }
        /*
			if (typeof question === "undefined") {
				jslog("i", "showQuestionsForUser: qid 1 " + question + "typeof "
						+ (typeof question === "undefined")
						+ JSON.stringify(global.question_for_student.unanswered_questions));
			}*/
        try {
            if (typeof question !== "undefined" && typeof question.id !== "undefined") {
                qid = question.id;
            }
        } catch (e) {
            jslog("e", "showQuestionsForUser 1:" + e + dumpvar(e));
            return askCreateLesson(); //return askBuyProAnswer();
        }
        try {
            /*	jslog("i", "showQuestionsForUser question = " + qid + " typeof "
					+ (typeof global.question_for_student.answered_questions[qid] !== "undefined") + " global.question_for_student.unanswered_questions "
					+ global.question_for_student.unanswered_questions.length);*/
        } catch (e) {
            jslog("e", "showQuestionsForUser 1:" + e + dumpvar(e));
        }
        if (typeof question === "undefined" || question == null || question == false) {
            //jslog("i", "showQuestionsForUser: proanswer 2 " + (typeof question === "undefined") + JSON.stringify(question));
            return askCreateLesson(); //return askBuyProAnswer();
        }

        //	question = Math.floor(Math.random() * (global.question_for_student.unanswered_questions.length));
        //	question = global.question_for_student.unanswered_questions.length - 1;
        window.localStorage.setItem("global.question_for_student", JSON.stringify(global.question_for_student));
        window.localStorage.setItem("resume_page", "questionsforuser");
        student_questions = document.getElementById("student_questions");
        /*jslog("i", "showQuestionsForUser: question = " + JSON.stringify(question) + ":length = "
					+ global.question_for_student.unanswered_questions.length + " postcondition " + question.postcondition);*/
        if (typeof question !== "undefined" && typeof question['question'] !== "undefined") {
            //		global.question_for_student.question = question;
            global.question_for_student.fields = question['fields'];
            global.question_for_student.qid = question['id'];
            if (typeof question['postcondition'] == "string")
                global.question_for_student.postcondition = question['postcondition'];
            else
                global.question_for_student.postcondition = null;
            setDivHTML('student_questions', question['question']);
            if (typeof question['hide_answer_button'] !== "undefined" && question['hide_answer_button'] > 0) {
                global.answer_button = true;
                hideDiv("answer_button");
            } else {
                if (typeof global.answer_button !== "undefined" && global.answer_button) {
                    showDiv("answer_button");
                    global.answer_button = false;
                }
            }
            if (typeof question['hide_skip_button'] !== "undefined" && question['hide_skip_button'] > 0) {
                global.skip_button = true;
                hideDiv("skip_button");
            } else {
                if (typeof global.skip_button !== "undefined" && global.skip_button) {
                    showDiv("skip_button");
                    global.skip_button = false;
                }
            }
            //jslog("i", "showing question id=" + question['id']);
            return switchMain("questionsforyoupage", 0, 'indexpage');
        } else {
            jslog("e", "showQuestionsForUser: proanswer 3 No questions defined");
            return askCreateLesson(); //return askBuyProAnswer();

        }
    } catch (e) {
        jslog("e", "showQuestionsForUser:" + e + dumpvar(e));
        return askCreateLesson(); //return askBuyProAnswer();
    }
    return askCreateLesson(); //return askBuyProAnswer();
}

function submitformQuestionForStudentValue(name, value) {
    try {
        id = document.getElementById(name);
        // this is show that the validate question works
        if (id != null) {
            id.value = value;
            //jslog("i", "submitformQuestionForStudentValue:" + name + "=" + value);
            submitformQuestionForStudent();
        } else {
            jslog("e", "submitformQuestionForStudentValue: id is null: " + name + ":" + value + "error id is null ");
            //skipQuestionForSudent();
        }
    } catch (e) {
        jslog("e", "submitformQuestionForStudentValue: catch error: " + name + ":" + value + "error:" + e + " " + dumpvar(e));
    }
}

function submitformQuestionForStudent(submit) {
    initQuestionForSudent();
    if (typeof global.question_for_student.fields !== "undefined") {
        if (!validateQuestionForStudent()) {
            if (typeof submit != "undefined" && submit && global.question_for_student.fields_len > 1) {
                //form was submitted and there was more then one field, just switch focus to next field	
            } else {
                centerMessage("Please complete the question", 0);
            }
            return false;
        }
    }
    addNewQuestionsToQueue();
    if (0) {
        //jslog("i", "submitformQuestionForStudent 1 " + JSON.stringify(global.question_for_student.unanswered_questions));
        //jslog("i", "submitformQuestionForStudent 1 " + JSON.stringify(global.question_for_student.next_questions));
    }
    saveQuestionForStudent();
    // question has been answered successfully and saved (post might be delayed)
    window.localStorage.removeItem("resume_page");
    //centerMessage("Thankyou, Your answer is very helpful");
    //	sendMessageToStudent(message_data);
    if (0) {
        //jslog("i", "submitformQuestionForStudent 2 " + JSON.stringify(global.question_for_student.unanswered_questions));
        //jslog("i", "submitformQuestionForStudent 2 " + JSON.stringify(global.question_for_student.next_questions));
    }
    var qid = global.question_for_student.qid;
    if (qid == 2 || qid == 3) {
        // ask user to answer another students question
        lessonSelectSubject();
    } else if (global.question_for_student.answered_questions_count >= global.max_survey_questions) {
        //max questions check
        // ask user to answer another students question
        //lessonSelectSubject();
        askCreateLesson();
        // show buy page
        //		askBuyProAnswer();
        return true;
    }
    showQuestionsForUser(1);
}

function getStudentData(field) {
    try {
        if (global.question_for_student != null && global.question_for_student.all_data != null && typeof global.question_for_student.all_data[field] !== "undefined")
            return global.question_for_student.all_data[field];
    } catch (e) {
        jslog("e", "getStudentData error " + e);
    }
    return false;
}

function addNewQuestionsToQueue() {
    try {
        if (typeof global.question_for_student.fields !== "undefined") {
            fields = global.question_for_student.fields.split(",");
            for (var i = 0; i < fields.length; i++) {
                field = fields[i];
                global.question_for_student.all_data[field] = getFormValue(field);
                //jslog("i", "addNewQuestionsToQueue: field = " + field + " value=" + global.question_for_student.all_data[field]);
            }
        }
    } catch (e) {
        jslog("e", "addNewQuestionsToQueue error 0" + e);
    }
    // eval condition
    // set fields
    // eval(global.question_for_student.condition)
    // add questions to queue
    //jslog("i", "addNewQuestionsToQueue: eval " + global.question_for_student.postcondition);
    try {
        if (typeof global.question_for_student.postcondition !== "undefined" && global.question_for_student.postcondition != null && global.question_for_student.postcondition != "") {
            var condition_questions = [];
            try {
                eval(global.question_for_student.postcondition);
                //jslog("i", "addNewQuestionsToQueue: condition_questions len " + condition_questions.length)
                for (var i = 0; i < condition_questions.length; i++) {
                    //jslog("i", "addNewQuestionsToQueue: condition_questions " + condition_questions[i])
                    global.question_for_student.next_questions.push(condition_questions[i]);
                }
            } catch (e) {
                jslog("e", "addNewQuestionsToQueue: eval error" + global.question_for_student.postcondition + " dump:" + dumpvar(e));
                return false;
            }

        }
        // reorganize unanswered queue and put these new ones at the top
        // if they are all ready cached
        nextQuestionsToRetrieve();
    } catch (e) {
        jslog("e", "addNewQuestionsToQueue" + e);
    }

}

/* loads variables from db
 * questionid
 * question_uuid
 * questionfileURI
 * success is typically askBuyProAnswer()
 */

function loadQuestion(tquestion_uuid, success) {
    var len = 0;
    try {
        len = global.questions.length;
    } catch (e) {}
    try {
        if (len > 0) {
            for (i = 0; i < len; i++) {
                if (global.questions[i].question_uuid == tquestion_uuid) {
                    jslog("i", "loadQuestion: question " + global.questions[i].questionid + " " + dumpvar(global.questions[i]));
                    global.question_uuid = tquestion_uuid;
                    global.questionfileURI = global.questions[i].questionfileURI;
                    global.description = global.questions[i].description;
                    global.questionid = global.questions[i].questionid;
                    return success();
                }
            }
        }
    } catch (e) {}
}

function skipProAnswer() {
    askCreateLesson();
}

function askBuyProAnswer() {
    try {
        if (0) {
            skipProAnswer();
        } else {
            setConfirmQuestion('buy_proanswer');
            switchMain('proanswerpage', 0, 'indexpage');
        }
    } catch (e) {
        jslog("e", "askBuyProAnswer:" + dumpvar(e));
    }
}

function showPaymentError() {
	if (isAndroid())
    genericMessage("<div class=\"errormsg\" style=\"max-width: 320px\">There was a problem connecting to Google Play, please make sure you are connected to the internet and Google Play is the latest version. Please try again later.</div>");
	else
    genericMessage("<div class=\"errormsg\" style=\"max-width: 320px\">There was a problem procesing your payment. Please try again later.</div>");
    //setConfirmQuestion('payment_error');
    //switchMain('payment_errorpage', 0, 'indexpage');
}

function saveQuestionForStudent() {
    try {
        initQuestionForSudent();
        var qid = global.question_for_student.qid;
        var data1 = {};
        if (typeof global.question_for_student.fields !== "undefined") {
            fields = global.question_for_student.fields.split(",");
            for (var i = 0; i < fields.length; i++) {
                field = fields[i];
                data1[field] = getFormValue(field);
                //global.question_for_student.all_data[field] = data1[field];
                //jslog("i", "saveQuestionForStudent: field = " + field + " value=" + data1[field]);
            }
        }
        var param1 = {};
        param1['question_id'] = global.questionid;
        param1['question_uuid'] = global.question_uuid;
        param1['student_question_id'] = qid;
        param1['student_question_data'] = JSON.stringify(data1);
        param1['next_questions'] = nextQuestionsToRetrieve();
        // now that question is answered pop it off the list
        //temp = global.question_for_student.unanswered_questions.pop();
        //jslog("i", "saveQuestionForStudent: param1 = " + JSON.stringify(data1) + " data1 = " + data1);
        //jslog("i", "saveQuestionForStudent: param1 = " + global.question_for_student.unanswered_questions.length);
        global.question_for_student.answered_questions_count++;
        global.question_for_student.answered_questions[qid] = param1;
        // this sets the school level that the student is in
        // in the future student needs to be able to change this
        // global.school_level should stay static
        if (qid == 1 && typeof data1["school_level"] !== "undefined") {
            // school_level
            global.school_level = data1["school_level"];
            window.localStorage.setItem("school_level", data1["school_level"]);
            setSuggestedQuestions("question");
        }
        //jslog("i", "saveQuestionForStudent: answered_questions = " + JSON.stringify(global.question_for_student.answered_questions));
        window.localStorage.setItem("global.question_for_student", JSON.stringify(global.question_for_student));
        /*
		window.localStorage.setItem("global.question_for_student.all_data", JSON
				.stringify(global.question_for_student.all_data));
		window.localStorage.setItem("global.question_for_student.next_questions", JSON
				.stringify(global.question_for_student.next_questions));
				
		window.localStorage.setItem("global.question_for_student.unanswered_questions", JSON
				.stringify(global.question_for_student.unanswered_questions));
			*/

        param1['url'] = global.siteUrl + '/app_' + global.app_version + '_questions_for_students';
        param1['posttype'] = 3;
        param1['callback'] = "addQuestionsToUnanswered";
        //jslog("i", "addUploadQueue saveQuestionForStudent");
        addUploadQueue(param1);
        processUploadQueue();
    } catch (e) {
        jslog("e", "saveQuestionForStudent " + e + " " + dumpvar(e));
    }
}

function nextQuestionsToRetrieve() {
    // pull from global.question_for_student.next_questions_queue
    //if (contains(global.question_for_student.next_questions,

    // build a list of current questions in unanswered_questions
    // check to see if question is all ready in global.questions_cache if so add to unanswered_questions
    // return the next_questions that are not found
    var get_queue = [];
    var current_questions = [];
    for (var i = 0; i < global.question_for_student.unanswered_questions.length; i++) {
        if (typeof global.question_for_student.unanswered_questions[i]['id'] !== "undefined" && contains(current_questions, global.question_for_student.unanswered_questions[i]['id']))
            current_questions.push(global.question_for_student.unanswered_questions[i]['id']);
    }
    for (var i = 0; i < global.question_for_student.next_questions.length; i++) {
        id = global.question_for_student.next_questions[i];
        if (typeof global.questions_cache[id] === "undefined") {
            get_queue.push(id);
        } else {
            if (!contains(current_questions, id)) {
                global.question_for_student.unanswered_questions.push(global.questions_cache[id]);
                delete global.questions_cache[id];
            }
        }
    }
    global.question_for_student.next_questions = get_queue;
    if (global.question_for_student.next_questions.length > 0)
        return global.question_for_student.next_questions;
    return false;
}

function addQuestionsToUnanswered(data) {
    // push to queue to prevent over writing
    global.addquestions_queue.push(data);
    process_addquestions_queue();
}

function process_addquestions_queue() {
    // process questions retrieved from an api call and add them to the global.questions_cache if they are
    // intended for a postcondition or add them to the unanswered questions list
    // 
    try {
        if (global.process_addquestions_queue_lock) {
            //jslog("i", "process_addquestions_queue locked finishing up ");
            return false;
        }
        global.process_addquestions_queue_lock = true;
        if (global.addquestions_queue.length == 0) {
            global.process_addquestions_queue_lock = false;
            return true;
        }
        //while (global.addquestions_queue.length) 
        data = global.addquestions_queue.pop();

        //add questions with contidtions met to unanswered queue list
        //add others to questions cache
        //jslog("i", "addQuestionsToUnanswered" + JSON.stringify(data['questions_for_student']));
        // prevent duplicates
        var current_questions = [];
        for (var i = 0; i < global.question_for_student.unanswered_questions.length; i++) {
            if (typeof global.question_for_student.unanswered_questions[i]['id'] !== "undefined" && contains(current_questions, global.question_for_student.unanswered_questions[i]['id']))
                current_questions.push(global.question_for_student.unanswered_questions[i]['id']);
        }
        //jslog("i", "unanswered ids" + dumpvar(current_questions));
        for (var key in data['questions_for_student']) {
            var id = null;
            try {
                //jslog("i", "data['questions_for_student'][" + key + "]=" + dumpvar(data['questions_for_student'][key]));

            } catch (e) {
                jslog("e", "addQuestionsToUnanswered key = " + key);
            }
            try {
                //jslog("i", "data 1 key = " + key);
                if (typeof data['questions_for_student'][key] === "undefined") {
                    jslog("e", "data['questions_for_student'][key] undefined" + JSON.stringify(data['questions_for_student']));
                } else {
                    //jslog("i", "data 1a ");
                    id = data['questions_for_student'][key]['id'];
                    parent_id = data['questions_for_student'][key]['parent_id'];
                    // if the parent_id is set then this question is only asked if a postcondition
                    // adds the question to the next list, other wise by default add question to next list
                    if (parent_id == null || parent_id == "" || parent_id == 0)
                        global.question_for_student.next_questions.push(id);
                    //jslog("i", "data 1b id = " + id + " " + typeof id);
                    if (contains(global.question_for_student.next_questions, id)) {
                        //jslog("i", "data 2 " + global.question_for_student.next_questions.indexOf(id));
                        idx = global.question_for_student.next_questions.indexOf(id);
                        var removed_id = global.question_for_student.next_questions.splice(idx, 1);
                        if (removed_id != id)
                            jslog("e", " removed_id != id " + removed_id + ":" + id)
                        if (!isAnswered(id) && !contains(current_questions, id)) {
                            // put generic questions that have parent_id of 0
                            // on front of queue so that triggered questions
                            // get asked first (testing needed)
                            if (parent_id == null || parent_id == "" || parent_id == 0)
                                global.question_for_student.unanswered_questions.unshift(data['questions_for_student'][key]);
                            else
                                global.question_for_student.unanswered_questions.push(data['questions_for_student'][key]);
                        }
                    } else {
                        //jslog("i", "data 3");
                        if (!isAnswered(id) && global.default_questions.indexOf(id) == -1)
                            global.questions_cache[id] = data['questions_for_student'][key];
                        //jslog("i", "data 4");
                    }
                }
            } catch (e) {
                jslog("e", "addQuestionsToUnanswered 1 key = " + key + " " + e);
            }
            //jslog("i", "data 5");

        }
        global.process_addquestions_queue_lock = false;

    } catch (e) {
        jslog("e", "process_addquestions_queue error" + dumpvar(e));
    }
}

function validateQuestionForStudent() {
    try {
        initQuestionForSudent();
        var qid = global.question_for_student.qid;
        var error = false;
        var error_fields = new Array();
        //jslog("i", "global.question_for_student.fields " + global.question_for_student.fields);
        if (typeof global.question_for_student.fields !== "undefined") {
            fields = global.question_for_student.fields.split(",");
            global.question_for_student.fields_len = fields.length;
            for (var i = 0; i < global.question_for_student.fields_len; i++) {
                field = fields[i];
                value = getFormValue(fields[i])
                if (value == "error-99") {
                    // then id does not exist
                } else if (value == "") {
                    if (!error) {
                        focusOnId(field);
                    }
                    error_fields.push(field);
                    error = true;
                }
            }
        }
        global.question_for_student.error = error;
        global.question_for_student.error_fields = error_fields;
        if (error)
            return false;
    } catch (e) {
        jslog("e", "validateQuestionForStudent error" + dumpvar(e));
    }
    return true;
}

function getFormValue(field) {
    try {
        // helper function to get value of input
        var id = document.getElementById(field);
        if (id == null) // id does not exist
            return "error-99";
        if (id != null) {
            switch (id.tagName.toLowerCase()) {
                case "select":
                    return id.options[id.selectedIndex].value;
                    break;
                case "textarea":
                case "input":
                    return id.value;
                    break;
            }
        }
    } catch (e) {
        jslog("e", "getFormValue" + dumpvar(e));
    }
    return null;
}

function setImage(field, imageURI) {
    try {
        smallImage = document.getElementById(field);
        if (smallImage != null) {
            // smallImage.src = imageURI;
            if (imageURI != null) {
                //addRandomUriString
                smallImage.src = (imageURI);
                smallImage.style.margin = "3px auto 3px auto";
                smallImage.style.height = "60px";
                smallImage.style.border = "1px solid gray"
                smallImage.style.display = "block";
            } else
                smallImage.style.display = "none";
        }
        return smallImage;
    } catch (e) {
        jslog("e", "setImage" + dumpvar(e));
    }

}

function setFormValue(field, value) {
    try {
        var id = document.getElementById(field);
        if (id == null) // id does not exist
            return "error-99";
        if (id != null) {
            switch (id.tagName.toLowerCase()) {
                case "select":
                    //			return id.options[id.selectedIndex].value;
                    break;
                case "textarea":
                case "input":
                    id.value = value;
                    break;
            }
        }
    } catch (e) {
        jslog("e", "setFormValue" + dumpvar(e));
    }
    return null;
}

function setConfirmQuestion(n) {
    try {
        id0 = document.getElementById(n + "0");
        id1 = document.getElementById(n + "1");
        var html = "<p>";
        if (global.description != null) {
            t = replaceAll("\n", "<br/>", global.description);
            html += t;
        }
        if (global.questionfileURI != null) {
            //addRandomUriString
            html += "<img src=\"" + (global.questionfileURI) + "\" style=\"max-width: 100%;\" />";
        }
        html += "</p>";
        //jslog("i", "setConfirmQuestion: html=" + html + " questionfileURI = " + global.questionfileURI);
        if (id0 != null)
            setDivHTML(n + "0", html);
        if (id1 != null)
            setDivHTML(n + "1", html);
    } catch (e) {
        jslog("e", "setConfirmQuestion: " + e + " " + dumpvar(e));
    }
}

function askCreateLesson() {
    // future show confirm page
    //setConfirmQuestion("thankyou_question_dest");
    setConfirmQuestion("askforhelp_quest");
    showAskforhelp();
    //setConfirmQuestion("question_view_dest");
    //switchMain('confirm_questionpage', 0, 'indexpage');
}

function showInstantAccess() {
    setConfirmQuestion("askforhelp_quest");
    showDiv("fullscreenpage");
    showDiv("viewquestion");
    hideDiv("askforhelp");
    global.current_page = "instantaccess";
    hideMainPage();
}

function hideInstantAccess() {
    hideDiv("fullscreenpage");
    showDiv("viewquestion");
    hideDiv("askforhelp");
    showMainPage();
}

function showAskforhelp() {
    setConfirmQuestion("askforhelp_quest");
    showDiv("fullscreenpage");
    hideDiv("viewquestion");
    showDiv("askforhelp");
    global.current_page = "askforhelp";
    hideMainPage();
}

function hideAskforhelp() {
    hideDiv("fullscreenpage");
    hideDiv("viewquestion");
    showDiv("askforhelp");
    showMainPage();
}

function hideMainPage() {
	closequestionupdate();
    hideDiv("menutable");
    hideDiv("swipeBox");
    showDiv("fullscreenpage");
	scrollToTop();
}

function showMainPage() {
    showDiv("menutable");
    showDiv("swipeBox");
    hideDiv("fullscreenpage");
	scrollToTop();
}

function saveEdit() {
    submitform(true);
}

function cancelEdit() {
    newQuestion();
}

function generateQuestionUuid() {
    global.question_uuid = getUuid() + "_" + new Date().getTime() + "_" + global.question_count;
    //jslog("i", "generateQuestionUuid " + global.question_uuid);
}

function newQuestion() {
    window.localStorage.setItem("resume_page", "newquestion");
    newQuestionPrep();
    global.upload_name = null;
    lessonCheckIfMoreNeeded();
    switchMain("indexpage", true);
}

function newQuestionPrep() {
    // only reset form if an edit was in progress
    // so to not wipe out a partly started question
    global.upload_name = null;
    resetForm();
    generateQuestionUuid();
}

// should access question id but that's for another day
function editQuestion() {
    //jslog("i", "editQuestion");
    id1 = document.getElementById("textarea1");
    if (global.description != null) {
        id1.value = global.description;
    } else {
        id1.value = "";
    }
    global.upload_name = null;
    //switch needs to be done early for setEditQuestionImage
    switchMain("editpage", 0, 'indexpage');
    if (global.questionfileURI != null) {
        setEditQuestionImage(global.questionfileURI);
    } else {
        setEditQuestionImage(null);
    }
    //jslog("i", "editQuestion: questionid = " + global.questionid);
}

function setProAnswerPrice(price) {
    try {
        var s = price.split(".");
        if (typeof s[0] !== "undefined")
            setDivHTML("dollarprice", s[0]);
        if (typeof s[1] !== "undefined")
            setDivHTML("centsprice", "." + s[1]);
        else
            setDivHTML("centsprice", "");
    } catch (e) {
        jslog("e", "setProAnswerPrice: price=:" + price + ":e=" + e + " " + dumpvar(e));
    }
}

function centerMessage(message, ntimeout) {
    var timeout = 2000;
    if (typeof ntimeout !== "undefined")
        timeout = ntimeout;
    var message_data = {
        message_for_student: {
            html: "<h1 class=\"heading1\">" + message + "</h1>",
            id: "thanks",
            track: false,
            location: "hover_center",
            timeout: timeout
        }
    }
    sendMessageToStudent(message_data);
}